'use strict';

angular.module('apMesa.ghPage', [
  'ngSanitize',
  'ngAnimate',
  'ngRoute',
  'apMesa'
])
.config(function ($routeProvider, $locationProvider) {
  $locationProvider.hashPrefix('');
  $routeProvider
    .when('/', {
      templateUrl: 'views/main.html',
      controller: 'MainCtrl'
    })
    .when('/perf', {
      templateUrl: 'views/perf.html',
      controller: 'PerfCtrl'
    })
    .when('/max-height', {
      templateUrl: 'views/max-height.html',
      controller: 'MaxHeightCtrl'
    })
    .when('/expandable', {
      templateUrl: 'views/expandable.html',
      controller: 'ExpandableCtrl'
    })
    .when('/server-side-interaction', {
      templateUrl: 'views/server-side-interaction.html',
      controller: 'ServerSideCtrl'
    })
    .when('/clickable-rows', {
      templateUrl: 'views/clickable-rows.html',
      controller: 'ClickableRowsCtrl'
    })
    .when('/disabled-columns', {
      templateUrl: 'views/disabled-columns.html',
      controller: 'DisabledColumnsCtrl',
      controllerAs: 'vm'
    })
    .otherwise({
      redirectTo: '/'
    });
})
.value('phoneData', [
  {
    'DeviceName': 'BLU Advance 4.0 L2',
    'Brand': 'BLU',
    'technology': 'GSM / HSPA',
    'gprs': 'Class 12',
    'edge': 'Class 12',
    'announced': '2016, April',
    'status': 'Available. Released 2016, April',
    'dimensions': '133.7 x 65.8 x 10.8 mm (5.26 x 2.59 x 0.43 in)',
    'weight': '122 g (4.30 oz)',
    'sim': 'Dual SIM (Mini-SIM, dual stand-by)',
    'type': 'TFT capacitive touchscreen, 16M colors',
    'size': '4.0 inches (~51.8% screen-to-body ratio)',
    'resolution': '480 x 800 pixels (~233 ppi pixel density)',
    'card_slot': 'microSD, up to 64 GB',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.0',
    'gps': 'Yes, with A-GPS',
    'radio': 'Stereo FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP3/AAC/WMA/WAV player\r\n  - DivX/XviD/MP4/H.264/WMV player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Removable Li-Ion 1300 mAh battery',
    'stand_by': 'Up to 700 h (2G) / Up to 500 h (3G)',
    'talk_time': 'Up to 17 h (2G) / Up to 12 h (3G)',
    'colors': 'Black, White, Green, Pink',
    'sensors': 'Accelerometer',
    'cpu': 'Quad-core 1.3 GHz Cortex-A7',
    'internal': '4 GB, 512 MB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'primary_': '3.15 MP, LED flash',
    'video': '720@30fps',
    'secondary': 'VGA',
    'speed': 'HSPA 21.1/5.76 Mbps',
    'network_c': 'HSDPA 850 / 1900 / 2100 - A030L',
    'chipset': 'Mediatek MT6580',
    'features': 'Geo-tagging',
    'gpu': 'Mali-400',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 1700(AWS) / 1900 - A030U'
  },
  {
    'DeviceName': 'BLU Dash X2',
    'Brand': 'BLU',
    'technology': 'GSM / HSPA',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, April',
    'status': 'Available. Released 2016, April',
    'dimensions': '145 x 73.1 x 9.7 mm (5.71 x 2.88 x 0.38 in)',
    'weight': '174 g (6.14 oz)',
    'sim': 'Dual SIM (Micro-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~65.0% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'card_slot': 'microSD, up to 64 GB',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0',
    'gps': 'Yes, with A-GPS',
    'radio': 'Stereo FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP3/AAC/WMA/WAV player\r\n  - MP4/DivX/XviD/WMV/H.264 player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Removable Li-Po 2200 mAh battery',
    'stand_by': 'Up to 750 h (2G) / Up to 700 h (3G)',
    'talk_time': 'Up to 25 h (2G) / Up to 14 h (3G)',
    'colors': 'Black, Gold, Rose Gold',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Quad-core 1.3 GHz Cortex-A7',
    'internal': '8 GB, 1 GB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'primary_': '8 MP, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP',
    'speed': 'HSPA 21.1/5.76 Mbps',
    'network_c': 'HSDPA 850 / 1900 / 2100 - D110L',
    'features': 'Geo-tagging, touch focus, face/smile detection',
    'gpu': 'Mali-400',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 1700(AWS) / 1900 - D110U'
  },
  {
    'DeviceName': 'BLU Dash M2',
    'Brand': 'BLU',
    'technology': 'GSM / HSPA',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, April',
    'status': 'Available. Released 2016, April',
    'dimensions': '145 x 73.4 x 9.8 mm (5.71 x 2.89 x 0.39 in)',
    'weight': '172 g (6.07 oz)',
    'sim': 'Dual SIM (Micro-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~64.7% screen-to-body ratio)',
    'resolution': '480 x 854 pixels (~196 ppi pixel density)',
    'card_slot': 'microSD, up to 64 GB',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0',
    'gps': 'Yes, with A-GPS',
    'radio': 'Stereo FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP3/AAC/WMA/WAV player\r\n  - MP4/DivX/XviD/WMV/H.264 player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Removable Li-Po 2000 mAh battery',
    'stand_by': 'Up to 800 h (2G) / Up to 700 h (3G)',
    'talk_time': 'Up to 26 h (2G) / Up to 14 h (3G)',
    'colors': 'Black, Gold, White, Rose Gold',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Quad-core 1.3 GHz Cortex-A7',
    'internal': '4 GB, 512 MB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'primary_': '5 MP, LED flash',
    'video': '1080p@30fps',
    'secondary': '2 MP',
    'speed': 'HSPA 21.1/5.76 Mbps',
    'network_c': 'HSDPA 850 / 1900 / 2100 - D090L',
    'features': 'Geo-tagging, touch focus',
    'gpu': 'Mali-400',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 1700(AWS) / 1900 - D090U'
  },
  {
    'DeviceName': 'QMobile Noir S9',
    'Brand': 'QMobile',
    'technology': 'GSM / HSPA',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, March',
    'status': 'Available. Released 2016, March',
    'dimensions': '143.5 x 69.4 x 8 mm (5.65 x 2.73 x 0.31 in)',
    'weight': '133 g (4.69 oz)',
    'sim': 'Dual SIM',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~69.2% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.0, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'Stereo FM radio',
    'usb': 'microUSB v2.0, USB Host',
    'messaging': 'SMS (threaded view), MMS, Email, Push Email',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/eAAC+/WAV/Flac player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Non-removable Li-Po 3000 mAh battery',
    'stand_by': 'Up to 430 h (2G) / Up to 410 h (3G)',
    'talk_time': 'Up to 12 h (2G) / Up to 10 h (3G)',
    'colors': 'White, Black',
    'sensors': 'Fingerprint, accelerometer, proximity, compass',
    'cpu': 'Octa-core 1.4 GHz Cortex-A7',
    'internal': '8 GB, 2 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '13 MP, f/2.2, autofocus, dual-LED (dual tone) flash',
    'video': '1080p@30fps',
    'secondary': '13 MP, f/2.2, autofocus, LED flash',
    'speed': 'HSPA 21.1/11.5 Mbps',
    'chipset': 'Mediatek MT6592M',
    'features': 'Geo-tagging, touch focus, face detection, HDR, panorama',
    'protection': 'Asahi Dragontrail Glass',
    'gpu': 'Mali-450MP4',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 900 / 1800 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 2100 '
  },
  {
    'DeviceName': 'QMobile Noir Z9 Plus',
    'Brand': 'QMobile',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, March',
    'status': 'Available. Released 2016, March',
    'dimensions': '155 x 76.4 x 7.2 mm (6.10 x 3.01 x 0.28 in)',
    'weight': '158 g (5.57 oz)',
    'sim': 'Dual SIM',
    'type': 'AMOLED capacitive touchscreen, 16M colors',
    'size': '5.5 inches (~70.4% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~267 ppi pixel density)',
    'display_c': '- Amigo OS 3.1',
    'card_slot': 'microSD, up to 128 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'v2.0, Type-C 1.0 reversible connector',
    'messaging': 'SMS (threaded view), MMS, Email, Push Email',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/eAAC+/WAV/Flac player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Removable Li-Ion 3150 mAh battery',
    'stand_by': 'Up to 315 h (2G) / Up to 252 h (3G)',
    'talk_time': 'Up to 21 h (2G) / Up to 9 h (3G)',
    'colors': 'White, Gold, Dark Blue',
    'sensors': 'Accelerometer, proximity, compass',
    'cpu': 'Octa-core 1.3 GHz Cortex-A53',
    'internal': '16 GB, 2 GB RAM',
    'os': 'Android OS, v5.1.1 (Lollipop)',
    'primary_': '13 MP, f/2.0, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP, f/2.8',
    'speed': 'HSPA, LTE Cat4 150/50 Mbps',
    'chipset': 'Mediatek MT6753',
    'features': 'Geo-tagging, touch focus, face detection, HDR, panorama',
    'protection': 'Corning Gorilla Glass 3',
    'gpu': 'Mali-T720MP3',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 7(2600), 20(800)'
  },
  {
    'DeviceName': 'Yezz CC40',
    'Brand': 'Yezz',
    'technology': 'GSM / HSPA',
    'gprs': 'Yes',
    'edge': 'No',
    'announced': '2016, March',
    'status': 'Available. Released Exp. release 2016, May',
    'dimensions': '107.4 x 46 x 14.4 mm (4.23 x 1.81 x 0.57 in)',
    'weight': '82.5 g (2.89 oz)',
    'sim': 'Mini-SIM',
    'type': 'TFT, 256K colors',
    'size': '1.8 inches (~20.6% screen-to-body ratio)',
    'resolution': '128 x 160 pixels (~114 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB (dedicated slot)',
    'phonebook': 'Yes',
    'call_records': 'Yes',
    'alert_types': 'Vibration, MP3, WAV',
    'loudspeaker_': 'Yes',
    'wlan': 'No',
    'bluetooth': 'v2.1',
    'gps': 'No',
    'radio': 'Stereo FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS, MMS',
    'browser': 'WAP 2.0',
    'games': 'No',
    'java': 'MIDP 2.0',
    'features_c': '- Video Player\r\n  - Music Player\r\n  - Organizer',
    'battery_c': 'Removable Li-Ion 800 mAh battery',
    'stand_by': 'Up to 160 h (2G) / Up to 130 h (3G)',
    'talk_time': 'Up to 6 h (2G) / Up to 4 h (3G)',
    'colors': 'Black',
    'sensors': 'No',
    'internal': '128 MB, 64 MB RAM',
    'primary_': 'VGA',
    'video': 'Yes',
    'secondary': 'No',
    'speed': 'HSPA 7.2/5.76 Mbps',
    'features': 'No',
    '_2g_bands': 'GSM 850 / 1900 ',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 1900 - CC40007'
  },
  {
    'DeviceName': 'vivo V3Max',
    'Brand': 'vivo',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, April',
    'status': 'Coming soon. Exp. release 2016, April',
    'dimensions': '153.9 x 77.1 x 7.6 mm (6.06 x 3.04 x 0.30 in)',
    'weight': '168 g (5.93 oz)',
    'sim': 'Dual SIM',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.5 inches (~70.3% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~401 ppi pixel density)',
    'display_c': '- Funtouch OS 2.5',
    'card_slot': 'microSD, up to 128 GB (uses SIM 2 slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'sound_c': '- Hi-Fi',
    'wlan': 'Yes',
    'bluetooth': 'v4.1, A2DP, LE',
    'gps': 'Yes, with A-GPS, GLONASS, BDS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0, USB Host',
    'messaging': 'SMS (threaded view), MMS, Email, Push Email',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/WAV/eAAC+/FLAC player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Non-removable Li-Ion 3000 mAh battery',
    'colors': 'Gold',
    'sensors': 'Fingerprint, accelerometer, gyro, proximity',
    'cpu': 'Quad-core 1.8 GHz Cortex-A72 & quad-core 1.4 GHz Cortex-A53',
    'internal': '32 GB, 4 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '13 MP, phase detection autofocus, LED flash',
    'video': 'Yes',
    'secondary': '8 MP',
    'speed': 'HSPA, LTE Cat4 150/50 Mbps',
    'chipset': 'Qualcomm MSM8976 Snapdragon 652',
    'features': 'Geo-tagging, touch focus, face detection, panorama, HDR',
    'gpu': 'Adreno 510',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 5(850), 7(2600), 8(900), 40(2300)'
  },
  {
    'DeviceName': 'vivo V3',
    'Brand': 'vivo',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, April',
    'status': 'Coming soon. Exp. release 2016, April',
    'dimensions': '143.6 x 71 x 7.5 mm (5.65 x 2.80 x 0.30 in)',
    'weight': '138 g (4.87 oz)',
    'sim': 'Dual SIM',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~67.6% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'display_c': '- Funtouch OS 2.5',
    'card_slot': 'microSD, up to 128 GB (uses SIM 2 slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'sound_c': '- Hi-Fi',
    'wlan': 'Yes',
    'bluetooth': 'v4.1, A2DP, LE',
    'gps': 'Yes, with A-GPS, GLONASS, BDS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0, USB Host',
    'messaging': 'SMS (threaded view), MMS, Email, Push Email',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/WAV/eAAC+/FLAC player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Non-removable Li-Ion 2550 mAh battery',
    'colors': 'Gold',
    'sensors': 'Fingerprint, accelerometer, gyro, proximity',
    'cpu': 'Quad-core 1.5 GHz Cortex-A53 & quad-core 1.0 GHz Cortex-A53',
    'internal': '16/32 GB, 3 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '13 MP, phase detection autofocus, LED flash',
    'video': 'Yes',
    'secondary': '8 MP',
    'speed': 'HSPA, LTE Cat4 150/50 Mbps',
    'network_c': 'LTE band 1(2100), 3(1800), 8(900) - Myanmar, Thailand, Vietnam',
    'chipset': 'Qualcomm MSM8939v2 Snapdragon 616',
    'features': 'Geo-tagging, touch focus, face detection, panorama, HDR',
    'gpu': 'Adreno 405',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 5(850), 7(2600), 8(900), 40(2300) - Malaysia, Philippines'
  },
  {
    'DeviceName': 'Samsung Galaxy Express Prime',
    'Brand': 'Samsung',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, April',
    'status': 'Available. Released 2016, April',
    'dimensions': '142.2 x 71.1 x 7.9 mm (5.60 x 2.80 x 0.31 in)',
    'weight': '138.9 g (4.90 oz)',
    'sim': 'Micro-SIM',
    'type': 'Super AMOLED capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~68.2% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'card_slot': 'microSD, up to 128 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.1, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio, RDS',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - MP4/H.264 player\r\n  - MP3/WAV/eAAC+/Flac player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Removable Li-Ion 2600 mAh battery',
    'stand_by': 'Up to 528 h',
    'talk_time': 'Up to 22 h',
    'colors': 'Black',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Quad-core 1.3 GHz Cortex-A7',
    'internal': '16 GB 1.5 GB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'primary_': '5 MP, f/2.2, autofocus, LED flash',
    'video': '720p@30fps',
    'secondary': '2 MP',
    'speed': 'HSPA 42.2/5.76 Mbps, LTE Cat4 150/50 Mbps',
    'chipset': 'Exynos 3475 Quad',
    'features': 'Geo-tagging, touch focus, face detection, HDR',
    'protection': 'Corning Gorilla Glass 4',
    'gpu': 'Mali-T720',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 ',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 2(1900), 3(1800), 4(1700/2100), 5(850), 7(2600), 12(700)'
  },
  {
    'DeviceName': 'Maxwest Gravity 5 LTE',
    'Brand': 'Maxwest',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, January',
    'status': 'Available. Released 2016, February',
    'dimensions': '145.5 x 72.8 x 8.9 mm (5.73 x 2.87 x 0.35 in)',
    'weight': '155 g (5.47 oz)',
    'sim': 'Dual SIM (Dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~65.1% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'card_slot': 'microSD, up to 64 GB',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': '4.1',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, IM',
    'browser': 'HTML',
    'java': 'No',
    'features_c': '- DivX/XviD/WMV/MP4/H.264 player\r\n  - MP3/WAV/WMA/AAC player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Removable Li-Ion 2200 mAh battery',
    'stand_by': 'Up to 300 h',
    'talk_time': 'Up to 7 h 30 min',
    'colors': 'Black/Silver/Gold',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Quad-core 1.1 GHz Cortex-A7',
    'internal': '8 GB, 1 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '8 MP, autofocus, LED flash',
    'video': 'Yes',
    'secondary': '2 MP',
    'speed': 'HSPA, LTE',
    'chipset': 'Qualcomm MSM8909 Snapdragon 210',
    'features': 'Geo-tagging, touch focus',
    'gpu': 'Adreno 304',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 1700(AWS) / 1900 ',
    '_4g_bands': 'LTE band 2(1900), 4(1700/2100), 7(2600), 17(700)'
  },
  {
    'DeviceName': 'vivo X6S Plus',
    'Brand': 'vivo',
    'technology': 'GSM / CDMA / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, March',
    'status': 'Coming soon. Exp. release 2016, April',
    'dimensions': '158.4 x 80.1 x 6.9 mm (6.24 x 3.15 x 0.27 in)',
    'weight': '172.5 g (6.10 oz)',
    'sim': 'Dual SIM',
    'type': 'Super AMOLED capacitive touchscreen, 16M colors',
    'size': '5.7 inches (~70.6% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~386 ppi pixel density)',
    'display_c': '- Funtouch OS',
    'card_slot': 'microSD, up to 128 GB (uses SIM 2 slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'sound_c': '- Hi-Fi',
    'wlan': 'Yes',
    'bluetooth': 'v4.2',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0, USB Host',
    'messaging': 'SMS (threaded view), MMS, Email, Push Email',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Fast battery charging\r\n  - Active noise cancellation with dedicated mic\r\n  - MP4/H.264 player\r\n  - MP3/WAV/eAAC+/FLAC player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Non-removable Li-Ion 3000 mAh battery',
    'colors': 'Silver, Gold, Rose Gold',
    'sensors': 'Fingerprint, accelerometer, gyro, proximity, compass',
    'cpu': 'Quad-core 1.8 GHz Cortex-A72 & quad-core 1.4 GHz Cortex-A53',
    'internal': '64 GB, 4 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '16 MP, f/2.0, phase detection autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '8 MP',
    'speed': 'HSPA, LTE',
    'network_c': ' TD-SCDMA',
    'chipset': 'Qualcomm MSM8976 Snapdragon 652',
    'features': 'Geo-tagging, touch focus, face detection, panorama, HDR',
    'gpu': 'Adreno 510',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 900 / 1800 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 2(1900), 3(1800), 4(1700/2100), 5(850), 8(900), 38(2600), 39(1900), 40(2300), 41(2500)'
  },
  {
    'DeviceName': 'vivo X6S',
    'Brand': 'vivo',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, March',
    'status': 'Coming soon. Exp. release 2016, April',
    'dimensions': '147.9 x 73.8 x 6.7 mm (5.82 x 2.91 x 0.26 in)',
    'weight': '140.5 g (4.97 oz)',
    'sim': 'Dual SIM (Nano-SIM/ Micro-SIM, dual stand-by)',
    'type': 'Super AMOLED capacitive touchscreen, 16M colors',
    'size': '5.2 inches (~68.3% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~424 ppi pixel density)',
    'display_c': '- Funtouch OS',
    'card_slot': 'microSD, up to 128 GB (uses SIM 2 slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'sound_c': '- Hi-Fi',
    'wlan': 'Yes',
    'bluetooth': 'v4.0',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0, USB Host',
    'messaging': 'SMS (threaded view), MMS, Email, Push Email',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Fast battery charging\r\n  - Active noise cancellation with dedicated mic\r\n  - MP4/H.264 player\r\n  - MP3/WAV/eAAC+/FLAC player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Non-removable Li-Ion 2400 mAh battery',
    'colors': 'Silver, Gold, Rose Gold',
    'sensors': 'Fingerprint, accelerometer, gyro, proximity, compass',
    'cpu': 'Quad-core 1.8 GHz Cortex-A72 & quad-core 1.4 GHz Cortex-A53',
    'internal': '64 GB, 4 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '13 MP, f/2.2, phase detection autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '8 MP, f/2.4',
    'speed': 'HSPA, LTE',
    'network_c': ' TD-SCDMA',
    'chipset': 'Qualcomm MSM8976 Snapdragon 652',
    'features': 'Geo-tagging, touch focus, face detection, panorama, HDR',
    'gpu': 'Adreno 510',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 900 / 1800 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 4(1700/2100), 38(2600), 39(1900), 40(2300), 41(2500)'
  },
  {
    'DeviceName': 'Philips S396',
    'Brand': 'Philips',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2015, June',
    'status': 'Available. Released 2015, June',
    'dimensions': '141.9 x 73 x 9.7 mm (5.59 x 2.87 x 0.38 in)',
    'weight': '151 g (5.33 oz)',
    'sim': 'Dual SIM',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~66.5% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'card_slot': 'microSD, up to 64 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.0, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP3/WAV/eAAC+/FLAC player\r\n  - MP4/H.264 player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Removable Li-Ion 2300 mAh battery',
    'colors': 'Black',
    'sensors': 'Accelerometer, proximity, compass',
    'cpu': 'Quad-core 1.0 GHz Cortex-A53',
    'internal': '8 GB, 1 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '8 MP, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '8 MP',
    'speed': 'HSPA 42.2/11.5 Mbps, LTE Cat4 150/50 Mbps',
    'chipset': 'Mediatek MT6735P',
    'features': 'Geo-tagging, touch focus, face detection',
    'gpu': 'Mali-T720MP2',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 7(2600), 20(800), 38(2600), 39(1900), 40(2300), 41(2500)'
  },
  {
    'DeviceName': 'Philips I908',
    'Brand': 'Philips',
    'technology': 'GSM / HSPA',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2015, August',
    'status': 'Available. Released 2015, August',
    'dimensions': '143 x 70 x 8.8 mm (5.63 x 2.76 x 0.35 in)',
    'weight': '156 g (5.50 oz)',
    'sim': 'Dual SIM',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~68.9% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~441 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.1, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP3/WAV/eAAC+/FLAC player\r\n  - MP4/H.264 player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Li-Ion 3000 mAh battery',
    'colors': 'Black, White',
    'sensors': 'Accelerometer, proximity, compass',
    'cpu': 'Octa-core 1.7 GHz',
    'internal': '16 GB, 2 GB RAM',
    'os': 'Android OS, v4.4.2 (KitKat)',
    'primary_': '13 MP, f/2.2, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP',
    'speed': 'HSPA 21.1/11.5 Mbps',
    'features': 'Geo-tagging, touch focus, face detection',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 2100 '
  },
  {
    'DeviceName': 'Philips V526',
    'Brand': 'Philips',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2015, August',
    'status': 'Available. Released 2015, August',
    'dimensions': '145 x 73.4 x 10 mm (5.71 x 2.89 x 0.39 in)',
    'weight': '189 g (6.67 oz)',
    'sim': 'Dual SIM',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~64.8% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'card_slot': 'microSD, up to 64 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.0, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP3/WAV/eAAC+/FLAC player\r\n  - MP4/H.264 player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Li-Ion 5000 mAh battery',
    'stand_by': 'Up to 1130 h',
    'talk_time': 'Up to 28 h',
    'colors': 'Black',
    'sensors': 'Accelerometer, proximity, compass',
    'cpu': 'Quad-core 1.3 GHz',
    'internal': '8 GB, 1 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '13 MP, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP',
    'speed': 'HSPA 42.2/11.5 Mbps, LTE Cat4 150/50 Mbps',
    'features': 'Geo-tagging, touch focus, face detection',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 7(2600), 20(800), 38(2600), 39(1900), 40(2300), 41(2500)'
  },
  {
    'DeviceName': 'Philips I928',
    'Brand': 'Philips',
    'technology': 'GSM / HSPA',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2015, September',
    'status': 'Available. Released 2015, September',
    'dimensions': '160.1 x 81.8 x 8.2 mm (6.30 x 3.22 x 0.32 in)',
    'weight': '168 g (5.93 oz)',
    'sim': 'Dual SIM',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '6.0 inches (~75.8% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~367 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v3.0, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP3/WAV/eAAC+/FLAC player\r\n  - MP4/H.264 player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Li-Ion 3000 mAh battery',
    'colors': 'Black, White',
    'sensors': 'Accelerometer, proximity, compass',
    'cpu': 'Octa-core 1.7 GHz',
    'internal': '16 GB, 2 GB RAM',
    'os': 'Android OS, v4.4 (KitKat)',
    'primary_': '13 MP, f/2.0, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '2 MP',
    'speed': 'HSPA 21.1/11.5 Mbps',
    'features': 'Geo-tagging, touch focus, face detection',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 2100 '
  },
  {
    'DeviceName': 'Xiaomi Mi Note 2',
    'Brand': 'Xiaomi',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': 'Not announced yet',
    'status': 'Rumored',
    'dimensions': '-',
    'weight': '-',
    'sim': 'Dual SIM (Nano-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.7 inches',
    'resolution': '2160 x 3840 pixels (~773 ppi pixel density)',
    'display_c': '- 3D Touch display',
    'card_slot': 'No',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 a/b/g/n/ac, dual-band, WiFi Direct, hotspot',
    'bluetooth': 'v4.2, A2DP, LE',
    'gps': 'Yes, with A-GPS, GLONASS, BDS',
    'radio': 'No',
    'usb': 'v3.0, Type-C 1.0 reversible connector',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Fast battery charging: 83% in 30 min (Quick Charge 3.0)\r\n  - Active noise cancellation with dedicated mic\r\n  - MP4/H.264 player\r\n  - MP3/WAV/eAAC+/Flac player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Non-removable Li-Ion 3600 mAh battery',
    'colors': 'Black, White',
    'sensors': 'Accelerometer, gyro, proximity, compass, barometer',
    'cpu': 'Dual-core 2.15 GHz Kryo & dual-core 1.6 GHz Kryo',
    'internal': '32/64/128 GB, 4/6 GB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'primary_': '16 MP, f/2.0, OIS, autofocus, dual-LED (dual tone) flash',
    'video': '2160p@30fps, 1080p@30fps',
    'secondary': '4 MP, f/2.0, 1080p (1/3 sensor size, 2Âµm pixel size)',
    'speed': 'HSPA, LTE',
    'network_c': ' TD-SCDMA',
    'chipset': 'Qualcomm MSM8996 Snapdragon 820',
    'features': '1/2.8\' sensor size, 1.12 Âµm pixel size, geo-tagging, touch focus, face detection, panorama, HDR',
    'protection': 'Corning Gorilla Glass 4',
    'gpu': 'Adreno 530',
    'multitouch': 'Yes',
    'build': 'Corning Gorilla Glass 4 back panel',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 3(1800), 7(2600), 38(2600), 39(1900), 40(2300), 41(2500)'
  },
  {
    'DeviceName': 'Gionee P5 Mini',
    'Brand': 'Gionee',
    'technology': 'GSM / HSPA',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, March',
    'status': 'Coming soon. Exp. release 2016, April',
    'dimensions': '132 x 66 x 9.1 mm (5.20 x 2.60 x 0.36 in)',
    'weight': '153 g (5.40 oz)',
    'sim': 'Dual SIM',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '4.5 inches (~64.1% screen-to-body ratio)',
    'resolution': '480 x 854 pixels (~218 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'Yes',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/WAV/eAAC+ player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Removable Li-Ion 1800 mAh battery',
    'colors': 'White, Black, Blue',
    'sensors': 'Accelerometer',
    'cpu': 'Quad-core 1.3 GHz Cortex-A7',
    'internal': '8 GB, 1 GB RAM',
    'os': 'Android OS, v5.0 (Lollipop)',
    'primary_': '5 MP, autofocus, LED flash',
    'video': 'Yes',
    'secondary': '2 MP',
    'speed': 'HSPA',
    'chipset': 'Mediatek MT6580M',
    'features': 'Geo-tagging, touch focus',
    'gpu': 'Mali-400MP2',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 2100 '
  },
  {
    'DeviceName': 'Philips S616',
    'Brand': 'Philips',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2015, November',
    'status': 'Available. Released 2015, November',
    'dimensions': '143 x 71.6 x 9.8 mm (5.63 x 2.82 x 0.39 in)',
    'weight': '164 g (5.78 oz)',
    'sim': 'Dual SIM',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.5 inches (~81.4% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~401 ppi pixel density)',
    'card_slot': 'microSD, up to 128 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.0, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP3/WAV/eAAC+/FLAC player\r\n  - MP4/H.264 player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Li-Ion 3000 mAh battery',
    'colors': 'Black',
    'sensors': 'Accelerometer, proximity, compass',
    'cpu': 'Octa-core 1.3 GHz',
    'internal': '16 GB, 2 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '13 MP, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': 'Yes',
    'speed': 'HSPA, LTE Cat4 150/50 Mbps',
    'features': 'Geo-tagging, touch focus, face detection',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 7(2600), 8(900), 20(800), 38(2600), 39(1900), 40(2300), 41(2500)'
  },
  {
    'DeviceName': 'Philips V787',
    'Brand': 'Philips',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2015, December',
    'status': 'Available. Released 2015, December',
    'dimensions': '143 x 71.6 x 9.8 mm (5.63 x 2.82 x 0.39 in)',
    'weight': '164 g (5.78 oz)',
    'sim': 'Dual SIM',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~67.3% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~441 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 a/b/g/n/ac, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP3/WAV/eAAC+/FLAC player\r\n  - MP4/H.264 player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Li-Ion 5000 mAh battery',
    'colors': 'Black',
    'sensors': 'Accelerometer, proximity, compass',
    'cpu': 'Octa-core 1.3 GHz',
    'internal': '16 GB, 2 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '13 MP, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP',
    'speed': 'HSPA, LTE Cat4 150/50 Mbps',
    'features': 'Geo-tagging, touch focus, face detection',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 2100 ',
    '_4g_bands': 'LTE band 38(2600), 39(1900), 40(2300), 41(2500)'
  },
  {
    'DeviceName': 'Philips V377',
    'Brand': 'Philips',
    'technology': 'GSM / HSPA',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2015, December',
    'status': 'Available. Released 2015, December',
    'dimensions': '145 x 74 x 10.9 mm (5.71 x 2.91 x 0.43 in)',
    'weight': '190 g (6.70 oz)',
    'sim': 'Dual SIM',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~64.2% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.0, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP3/WAV/eAAC+/FLAC player\r\n  - MP4/H.264 player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Li-Ion 5000 mAh battery',
    'stand_by': 'Up to 1100 h',
    'talk_time': 'Up to 29 h',
    'colors': 'Black',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Quad-core 1.3 GHz',
    'internal': '8 GB, 1 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '5 MP, autofocus, LED flash',
    'video': 'Yes',
    'secondary': 'Yes',
    'speed': 'HSPA 42.2/11.5 Mbps',
    'features': 'Geo-tagging',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 2100 '
  },
  {
    'DeviceName': 'Philips S309',
    'Brand': 'Philips',
    'technology': 'GSM / HSPA',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2015, July',
    'status': 'Available. Released 2015, July',
    'dimensions': '127.6 x 64.7 x 10.8 mm (5.02 x 2.55 x 0.43 in)',
    'weight': '127 g (4.48 oz)',
    'sim': 'Dual SIM (Mini-SIM, dual stand-by)',
    'type': 'Capacitive touchscreen, 16M colors',
    'size': '4.0 inches (~55.2% screen-to-body ratio)',
    'resolution': '480 x 800 pixels (~233 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.0, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP3/WAV/eAAC+/FLAC player\r\n  - MP4/H.264 player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Removable Li-Ion 1600 mAh battery',
    'stand_by': 'Up to 500 h (3G)',
    'talk_time': 'Up to 9 h 30 min (3G)',
    'colors': 'Black, Red',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Dual-core 1.0 GHz',
    'internal': '8 GB, 1 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '5 MP, autofocus, LED flash',
    'video': 'Yes',
    'secondary': 'VGA',
    'speed': 'HSPA 21.1/5.76 Mbps',
    'features': 'Geo-tagging',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 2100 '
  },
  {
    'DeviceName': 'Philips S337',
    'Brand': 'Philips',
    'technology': 'GSM / HSPA',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2015, October',
    'status': 'Available. Released 2015, November',
    'dimensions': '144.8 x 72.5 x 10.4 mm (5.70 x 2.85 x 0.41 in)',
    'weight': '152 g (5.36 oz)',
    'sim': 'Dual SIM (Mini-SIM, dual stand-by)',
    'type': 'Capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~65.6% screen-to-body ratio)',
    'resolution': '480 x 854 pixels (~196 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.0, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP3/WAV/eAAC+/FLAC player\r\n  - MP4/H.264 player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Removable Li-Ion 2000 mAh battery',
    'stand_by': 'Up to 480 h (3G)',
    'talk_time': 'Up to 6 h 40 min (3G)',
    'colors': 'Black',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Quad-core 1.3 GHz',
    'internal': '8 GB, 1 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '5 MP, autofocus, LED flash',
    'video': 'Yes',
    'secondary': 'VGA',
    'speed': 'HSPA 21.1/5.76 Mbps',
    'features': 'Geo-tagging',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 2100 '
  },
  {
    'DeviceName': 'Xiaomi Redmi 3 Pro',
    'Brand': 'Xiaomi',
    'technology': 'GSM / CDMA / HSPA / EVDO / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, March',
    'status': 'Coming soon. Exp. release 2016, April',
    'dimensions': '139.3 x 69.6 x 8.5 mm (5.48 x 2.74 x 0.33 in)',
    'weight': '144 g (5.08 oz)',
    'sim': 'Dual SIM (Micro-SIM/Nano-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~71.1% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'display_c': '- MIUI 7.0',
    'card_slot': 'microSD, up to 128 GB (uses SIM 2 slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.1, A2DP',
    'gps': 'Yes, with A-GPS, GLONASS, BDS',
    'infrared_port': 'Yes',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Fast battery charging\r\n  - Active noise cancellation with dedicated mic\r\n  - DivX/Xvid/MP4/H.264 player\r\n  - MP3/WAV/eAAC+/FLAC player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Non-removable Li-Ion 4100 mAh battery',
    'colors': 'Dark Gray, Silver, Gold',
    'sensors': 'Fingerprint, accelerometer, gyro, proximity, compass',
    'cpu': 'Quad-core 1.5 GHz Cortex-A53 & quad-core 1.2 GHz Cortex-A53',
    'internal': '32 GB, 3 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '13 MP, f/2.0, phase detection autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP, f/2.2, 1080p@30fps',
    'speed': 'HSPA, LTE, EV-DO Rev.A 3.1 Mbps',
    'network_c': 'CDMA2000 1xEV-DO ',
    'chipset': 'Qualcomm MSM8939v2 Snapdragon 616',
    'features': 'Geo-tagging, touch focus, face/smile detection, HDR, panorama',
    'gpu': 'Adreno 405',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 7(2600), 38(2600), 39(1900), 40(2300), 41(2500)'
  },
  {
    'DeviceName': 'Gionee W909',
    'Brand': 'Gionee',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, March',
    'status': 'Coming soon. Exp. release 2016, Q2',
    'dimensions': '124.1 x 62.8 x 16.5 mm (4.89 x 2.47 x 0.65 in)',
    'weight': '207.7 g (7.41 oz)',
    'sim': 'Yes',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '4.2 inches (~62.4% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~350 ppi pixel density)',
    'display_c': '- External IPS LCD capacitive touchscreen, 16M colors\r\n  720 x 1280 pixels, 4.2 inches',
    'card_slot': 'microSD, up to 128 GB',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0, A2DP, LE',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'Type-C 1.0 reversible connector',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/WAV/eAAC+/FLAC player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Li-Ion 2530 mAh battery',
    'colors': 'Rose gold/Black',
    'sensors': 'Fingerprint, accelerometer, proximity',
    'cpu': 'Octa-core',
    'internal': '64 GB, 4 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '16 MP, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP',
    'speed': 'HSPA, LTE',
    'chipset': 'Mediatek MT6755 Helio P10',
    'features': 'Geo-tagging, touch focus, face/smile detection, panorama, HDR',
    'gpu': 'Mali-T860MP2',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 900 / 1800 / 1900 ',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': ' HSDPA',
    '_4g_bands': ' LTE'
  },
  {
    'DeviceName': 'Meizu m3 note',
    'Brand': 'Meizu',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, April',
    'status': 'Coming soon. Exp. release 2016, April',
    'dimensions': '153.6 x 75.5 x 8.2 mm (6.05 x 2.97 x 0.32 in)',
    'weight': '163 g (5.75 oz)',
    'sim': 'Dual SIM (Nano-SIM, dual stand-by)',
    'type': 'LTPS IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.5 inches (~71.2% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~403 ppi pixel density)',
    'display_c': '- Flyme UI',
    'card_slot': 'microSD, up to 128 GB (uses SIM 2 slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 a/b/g/n, dual-band, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0, A2DP, LE',
    'gps': 'Yes, with A-GPS, GLONASS',
    'radio': 'No',
    'usb': 'microUSB v2.0, USB Host',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - MP3/WAV/eAAC+/FLAC player\r\n  - MP4/H.264 player\r\n  - Document editor\r\n  - Photo/video editor',
    'battery_c': 'Non-removable 4100 mAh battery',
    'colors': 'Gray, White, Gold',
    'sensors': 'Fingerprint, accelerometer, gyro, proximity, compass',
    'cpu': 'Quad-core 1.8 GHz Cortex-A53 & quad-core 1.0 GHz Cortex-A53',
    'internal': '16 GB, 2 GB RAM or 32 GB, 3 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '13 MP, f/2.2, phase detection autofocus, dual-LED (dual tone) flash',
    'video': '1080p@30fps',
    'secondary': '5 MP, f/2.0, 1080p',
    'speed': 'HSPA 42.2/5.76 Mbps, LTE Cat6 300/50 Mbps',
    'network_c': ' TD-SCDMA',
    'chipset': 'Mediatek MT6755 Helio P10',
    'features': 'Geo-tagging, touch focus, face detection, HDR, panorama',
    'protection': 'Dinorex T2X-1 scratch/shock resistant glass',
    'gpu': 'Mali-T860MP2',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 7(2600), 38(2600), 39(1900), 40(2300), 41(2500)'
  },
  {
    'DeviceName': 'Samsung Galaxy S7 Active',
    'Brand': 'Samsung',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': 'Not announced yet',
    'status': 'Rumored',
    'dimensions': '-',
    'weight': '-',
    'sim': 'Single SIM (Nano-SIM) or Dual SIM (Nano-SIM, dual stand-by)',
    'type': 'Super AMOLED capacitive touchscreen, 16M colors',
    'size': '5.1 inches',
    'resolution': '1440 x 2560 pixels (~576 ppi pixel density)',
    'display_c': '- Always-on display\r\n  - TouchWiz UI',
    'card_slot': 'microSD, up to 200 GB (dedicated slot) - single-SIM model\r\nmicroSD, up to 200 GB (uses SIM 2 slot) - dual-SIM model',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 a/b/g/n/ac, dual-band, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.2, A2DP, LE, apt-X',
    'gps': 'Yes, with A-GPS, GLONASS, BDS',
    'radio': 'No',
    'usb': 'microUSB v2.0, USB Host',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Fast battery charging: 60% in 30 min (Quick Charge 2.0)\r\n  - Wireless charging (Qi/PMA) - market dependent\r\n  - ANT+ support\r\n  - S-Voice natural language commands and dictation\r\n  - OneDrive (115 GB cloud storage)\r\n  - Active noise cancellation with dedicated mic\r\n  - MP4/DivX/XviD/WMV/H.264 player\r\n  - MP3/WAV/WMA/eAAC+/FLAC player\r\n  - Photo/video editor\r\n  - Document editor',
    'battery_c': 'Non-removable battery',
    'colors': 'White, Gray, Gold',
    'sensors': 'Fingerprint, accelerometer, gyro, proximity, compass, barometer, heart rate, SpO2',
    'cpu': 'Dual-core 2.15 GHz Kryo & dual-core 1.6 GHz Kryo',
    'internal': '32/64 GB, 4 GB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'body_c': '- Samsung Pay (Visa, MasterCard certified)\r\n  - IP68 certified - dust proof and water resistant over 1.5 meter and 30 minutes\r\n  - MIL-STD-810G certified - salt, dust, humidity, rain, vibration, solar radiation, transport and thermal shock resistant',
    'primary_': '12 MP, f/1.7, 26mm, phase detection autofocus, OIS, LED flash',
    'video': '2160p@30fps, 1080p@60fps, 720p@240fps, HDR, dual-video rec.',
    'secondary': '5 MP, f/1.7, 22mm, dual video call, Auto HDR',
    'speed': 'HSPA 42.2/5.76 Mbps, LTE Cat9 450/50 Mbps',
    'chipset': 'Qualcomm MSM8996 Snapdragon 820',
    'features': '1/2.6\' sensor size, 1.4 Âµm pixel size, geo-tagging, simultaneous 4K video and 9MP image recording, touch focus, face/smile detection, Auto HDR, panorama',
    'protection': 'Corning Gorilla Glass 4',
    'gpu': 'Adreno 530',
    'multitouch': 'Yes',
    'nfc': 'Yes',
    'build': 'Corning Gorilla Glass 4 back panel',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2 (dual-SIM model only)',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 ',
    '_4g_bands': ' LTE'
  },
  {
    'DeviceName': 'BLU Studio X Mini',
    'Brand': 'BLU',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, March',
    'status': 'Available. Released 2016, March',
    'dimensions': '133.7 x 65.8 x 10.8 mm (5.26 x 2.59 x 0.43 in)',
    'weight': '122 g (4.30 oz)',
    'sim': 'Dual SIM (Micro-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '4.5 inches (~63.4% screen-to-body ratio)',
    'resolution': '480 x 854 pixels (~218 ppi pixel density)',
    'card_slot': 'microSD, up to 64 GB',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0',
    'gps': 'Yes, with A-GPS',
    'radio': 'Stereo FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP3/AAC/WMA/WAV player\r\n  - MP4/DivX/XviD/WMV/H.264 player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Removable Li-Po 1800 mAh battery',
    'stand_by': 'Up to 700 h (2G) / Up to 600 h (3G)',
    'talk_time': 'Up to 23 h (2G) / Up to 14 h (3G)',
    'colors': 'Black, White',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Quad-core 1.0 GHz Cortex-A53',
    'internal': '8 GB, 1 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '5 MP, f/2.8, autofocus, LED flash',
    'video': '720p@30fps',
    'secondary': 'VGA',
    'speed': 'HSPA 21.1/5.76 Mbps, LTE Cat4 150/50 Mbps',
    'network_c': 'LTE band 2(1900), 3(1800), 7(2600), 28(700) - S0151UU',
    'chipset': 'Mediatek MT6735',
    'features': '1/4\' sensor size, geo-tagging, touch focus, face detection',
    'gpu': 'Mali-T720',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 1700(AWS) / 1900 / 2100 - S0150UU',
    '_4g_bands': 'LTE band 2(1900), 4(1700/2100), 7(2600), 17(700) - S0150UU'
  },
  {
    'DeviceName': 'YU YU5200',
    'Brand': 'YU',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': 'Not announced yet',
    'status': 'Rumored',
    'weight': '-',
    'sim': 'Dual SIM (Micro-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.2 inches',
    'resolution': '1080 x 1920 pixels (~424 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.0, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS (threaded view), MMS, Email, Push Email',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - MP4/H.264 player\r\n  - MP3/eAAC+/WAV/Flac player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Removable Li-Po battery',
    'colors': 'Moondust Gray, Alabaster White',
    'sensors': 'Accelerometer, gyro, proximity',
    'cpu': 'Quad-core 1.7 GHz Cortex-A53 & quad-core 1.0 GHz Cortex-A53',
    'internal': '16 GB, 3 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '13 MP, f/2.2, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP',
    'speed': 'HSPA 42.2/11.5 Mbps, LTE Cat4 150/50 Mbps',
    'chipset': 'Qualcomm MSM8939 Snapdragon 615',
    'features': '1/3\' sensor size, 1.12 Âµm pixel size, geo-tagging, touch focus, face detection, panorama',
    'gpu': 'Adreno 405',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 2100 ',
    '_4g_bands': 'LTE band 3(1800), 40(2300)'
  },
  {
    'DeviceName': 'Allview X3 Soul Pro',
    'Brand': 'Allview',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Available. Released 2016, February',
    'dimensions': '154.3 x 74.9 x 7 mm (6.07 x 2.95 x 0.28 in)',
    'weight': '144 g (5.08 oz)',
    'sim': 'Dual SIM (Micro-SIM/Nano-SIM, dual stand-by)',
    'type': 'AMOLED capacitive touchscreen, 16M colors',
    'size': '5.5 inches (~72.2% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~401 ppi pixel density)',
    'card_slot': 'microSD, up to 128 GB (uses SIM 2 slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.0, A2DP, EDR',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'v2.0, Type-C 1.0 reversible connector',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - MP4/H.264 player\r\n  - MP3/WAV/eAAC+ player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Non-removable Li-Po 3000 mAh battery',
    'stand_by': 'Up to 300 h (3G)',
    'talk_time': 'Up to 15 h 20 min (3G)',
    'colors': 'Gold, Silver',
    'sar_eu': '  0.86 W/kg (head) &nbsp; &nbsp; ',
    'sensors': 'Fingerprint, accelerometer, proximity, compass',
    'cpu': 'Octa-core 2.0 GHz Cortex-A53',
    'internal': '64 GB, 4 GB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'primary_': '16 MP, f/1.8, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '8 MP',
    'speed': 'HSPA 21.1/5.76 Mbps, LTE Cat6 300/50 Mbps',
    'chipset': 'Mediatek MT6755 Helio P10',
    'features': 'Geo-tagging, touch focus, face/smile detection, panorama, HDR',
    'protection': 'Corning Gorilla Glass 3',
    'gpu': 'Mali-T860MP2',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 7(2600), 20(800), 38(2600), 39(1900), 40(2300), 41(2500)'
  },
  {
    'DeviceName': 'Allview X3 Soul mini',
    'Brand': 'Allview',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Available. Released 2016, February',
    'dimensions': '142.6 x 69.5 x 7.2 mm (5.61 x 2.74 x 0.28 in)',
    'weight': '129 g (4.55 oz)',
    'sim': 'Dual SIM (Micro-SIM/Nano-SIM, dual stand-by)',
    'type': 'LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~69.5% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'card_slot': 'microSD, up to 128 GB (uses SIM 2 slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.0, A2DP, EDR',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/WAV/eAAC+ player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Non-removable Li-Po 2350 mAh battery',
    'stand_by': 'Up to 235 h (3G)',
    'talk_time': 'Up to 12 h (3G)',
    'colors': 'Gray, Gold, Silver',
    'sensors': 'Accelerometer, proximity, compass',
    'cpu': 'Quad-core 1.3 GHz Cortex-A53',
    'internal': '16 GB, 1 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '13 MP, f/2.2, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP',
    'speed': 'HSPA 21.1/5.76 Mbps, LTE Cat4 150/50 Mbps',
    'chipset': 'Mediatek MT6735',
    'features': 'Geo-tagging, touch focus, face/smile detection, panorama, HDR',
    'gpu': 'Mali-T720',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 2100 ',
    '_4g_bands': 'LTE band 3(1800), 7(2600), 20(800), 38(2600)'
  },
  {
    'DeviceName': 'Allview P8 Energy Pro',
    'Brand': 'Allview',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Class 12',
    'edge': 'Class 10',
    'announced': '2016, February',
    'status': 'Available. Released 2016, February',
    'dimensions': '160.9 x 81.2 x 8.4 mm (6.33 x 3.20 x 0.33 in)',
    'weight': '209.8 g (7.37 oz)',
    'sim': 'Dual SIM (Micro-SIM, dual stand-by)',
    'type': 'AMOLED capacitive touchscreen, 16M colors',
    'size': '6.0 inches (~76.0% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~367 ppi pixel density)',
    'card_slot': 'microSD, up to 128 GB',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n',
    'bluetooth': 'v4.0, A2DP, EDR',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'v3.0, Type-C 1.0 reversible connector',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/WAV/eAAC+ player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Non-removable Li-Po 5020 mAh battery',
    'stand_by': 'Up to 450 h',
    'talk_time': 'Up to 22 h 30 min',
    'colors': 'Gold/Silver',
    'sar_eu': '  0.40 W/kg (head) &nbsp; &nbsp; ',
    'sensors': 'Fingerprint, accelerometer, proximity, compass',
    'cpu': 'Octa-core 1.3 GHz Cortex-A53',
    'internal': '64 GB, 3 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '13 MP, f/2.0, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP',
    'speed': 'HSPA 21.1/5.76 Mbps, LTE Cat4 150/50 Mbps',
    'chipset': 'Mediatek MT6753',
    'features': 'Geo-tagging, touch focus, face detection, HDR, panorama',
    'protection': 'Corning Gorilla Glass 3',
    'gpu': 'Mali-T720MP2',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 7(2600), 38(2600), 39(1900), 40(2300)'
  },
  {
    'DeviceName': 'Allview P6 eMagic',
    'Brand': 'Allview',
    'technology': 'GSM / HSPA',
    'gprs': 'Class 12',
    'edge': 'Class 10',
    'announced': '2016, March',
    'status': 'Available. Released 2016, March',
    'dimensions': '145 x 72 x 9.7 mm (5.71 x 2.83 x 0.38 in)',
    'weight': '138 g (4.87 oz)',
    'sim': 'Dual SIM (Micro-SIM, dual stand-by)',
    'type': 'Capacitive touchscreen',
    'size': '5.0 inches (~66.0% screen-to-body ratio)',
    'resolution': '480 x 854 pixels (~196 ppi pixel density)',
    'card_slot': 'microSD, up to 128 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n',
    'bluetooth': 'v4.0, A2DP, EDR',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/WAV/eAAC+ player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Removable Li-Po 2300 mAh battery',
    'stand_by': 'Up to 153 h',
    'talk_time': 'Up to 11 h 30 min',
    'colors': 'Gold, Brown',
    'sar_eu': '  0.44 W/kg (head) &nbsp; &nbsp; ',
    'sensors': 'Accelerometer, proximity, compass',
    'cpu': 'Quad-core 1.3 GHz Cortex-A7',
    'internal': '16 GB, 1 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '8 MP, autofocus, LED flash',
    'video': '720p@30fps',
    'secondary': '2 MP',
    'speed': 'HSPA 21.1/5.76 Mbps',
    'chipset': 'Mediatek MT8321',
    'features': 'Geo-tagging, touch focus, face detection, HDR, panorama',
    'gpu': 'Mali-400',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 900 / 1800 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 2100 '
  },
  {
    'DeviceName': 'Allview P5 eMagic',
    'Brand': 'Allview',
    'technology': 'GSM / HSPA',
    'gprs': 'Class 12',
    'edge': 'Class 10',
    'announced': '2016, March',
    'status': 'Available. Released 2016, March',
    'dimensions': '133.1 x 66.5 x 9 mm (5.24 x 2.62 x 0.35 in)',
    'weight': '105 g (3.70 oz)',
    'sim': 'Dual SIM (Micro-SIM, dual stand-by)',
    'type': 'Capacitive touchscreen',
    'size': '4.5 inches (~65.1% screen-to-body ratio)',
    'resolution': '480 x 800 pixels (~207 ppi pixel density)',
    'card_slot': 'microSD, up to 128 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n',
    'bluetooth': 'v4.0, A2DP, EDR',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/WAV/eAAC+ player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Removable Li-Po 1600 mAh battery',
    'stand_by': 'Up to 160 h',
    'talk_time': 'Up to 7 h 40 min',
    'colors': 'Dark blue, Gold',
    'sar_eu': '  1.03 W/kg (head) &nbsp; &nbsp; ',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Quad-core 1.3 GHz Cortex-A7',
    'internal': '8 GB, 1 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '5 MP, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '2 MP',
    'speed': 'HSPA 21.1/5.76 Mbps',
    'chipset': 'Mediatek MT6580',
    'features': 'Geo-tagging, touch focus, HDR',
    'gpu': 'Mali-400',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 900 / 1800 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 2100 '
  },
  {
    'DeviceName': 'Allview P4 eMagic',
    'Brand': 'Allview',
    'technology': 'GSM / HSPA',
    'gprs': 'Class 12',
    'edge': 'Class 10',
    'announced': '2016, March',
    'status': 'Available. Released 2016, March',
    'dimensions': '125.6 x 64.4 x 10 mm (4.94 x 2.54 x 0.39 in)',
    'weight': '105 g (3.70 oz)',
    'sim': 'Dual SIM (Mini-SIM/ Micro-SIM, dual stand-by)',
    'type': 'Capacitive touchscreen',
    'size': '4.0 inches (~56.3% screen-to-body ratio)',
    'resolution': '480 x 800 pixels (~233 ppi pixel density)',
    'card_slot': 'microSD, up to 128 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n',
    'bluetooth': 'v4.0, A2DP, EDR',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/WAV/eAAC+ player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Removable Li-Ion 1400 mAh battery',
    'stand_by': 'Up to 200 h',
    'talk_time': 'Up to 7 h',
    'colors': 'Black',
    'sar_eu': '  0.67 W/kg (head) &nbsp; &nbsp; ',
    'sensors': 'Accelerometer',
    'cpu': 'Quad-core 1.3 GHz Cortex-A7',
    'internal': '8 GB, 1 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '5 MP, LED flash',
    'video': '1080p@30fps',
    'secondary': '2 MP',
    'speed': 'HSPA 21.1/5.76 Mbps',
    'chipset': 'Mediatek MT6580',
    'features': 'Geo-tagging, touch focus, HDR',
    'gpu': 'Mali-400',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 2100 '
  },
  {
    'DeviceName': 'OnePlus 3',
    'Brand': 'OnePlus',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': 'Not announced yet',
    'status': 'Rumored',
    'dimensions': '-',
    'weight': '-',
    'sim': 'Dual SIM (Nano-SIM, dual stand-by)',
    'type': 'LTPS IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.5 inches',
    'resolution': '1080 x 1920 pixels (~401 ppi pixel density)',
    'card_slot': 'No',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 a/b/g/n/ac, Wi-Fi Direct, DLNA, hotspot',
    'bluetooth': 'v4.2, A2DP, LE',
    'gps': 'Yes, with A-GPS, GLONASS',
    'radio': 'No',
    'usb': 'v3.0, Type-C 1.0 reversible connector',
    'messaging': 'SMS (threaded view), MMS, Email, IM, Push Email',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - DivX/Xvid/MP4/H.265 player\r\n  - MP3/eAAC+/WMA/WAV/FLAC player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Non-removable battery',
    'colors': 'Black',
    'sensors': 'Fingerprint, accelerometer, gyro, proximity, compass',
    'cpu': 'Dual-core 2.15 GHz Kryo & dual-core 1.6 GHz Kryo',
    'internal': '32 GB, 4 GB RAM\r\n64 GB, 6 GB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'primary_': '16 MP, f/1.8, OIS, laser autofocus, dual-LED flash',
    'video': '2160p@30fps',
    'secondary': '8 MP, f/2.0, 1080p',
    'speed': 'HSPA 42.2/5.76 Mbps, LTE Cat9 450/50 Mbps',
    'network_c': 'LTE band 1(2100), 3(1800), 5(850), 7(2600), 8(900), 20(800), 38(2600), 40(2300), 41(2500) - Global model',
    'chipset': 'Qualcomm MSM8996 Snapdragon 820',
    'features': '1/2.6\' sensor size, 1.3 Âµm pixel size, geo-tagging, touch focus, face detection, panorama, HDR',
    'protection': 'Corning Gorilla Glass 4',
    'gpu': 'Adreno 530',
    'multitouch': 'Yes',
    'nfc': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1700(AWS) / 1900 / 2100 - North America',
    '_4g_bands': 'LTE band 1(2100), 2(1900), 4(1700/2100), 5(850), 7(2600), 8(900), 12(700), 17(700) - North America'
  },
  {
    'DeviceName': 'Panasonic P66',
    'Brand': 'Panasonic',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Available. Released 2016, February',
    'dimensions': '142.4 x 70.9 x 8.4 mm (5.61 x 2.79 x 0.33 in)',
    'weight': '155 g (5.47 oz)',
    'sim': 'Dual SIM',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~68.3% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v2.1, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio, RDS',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/WAV/eAAC player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Li-Ion 3200 mAh battery',
    'colors': 'Rose Gold, Russet Brown & Electric Blue',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Quad-core 1.3 GHz',
    'internal': '16 GB, 2 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '8 MP, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP, LED flash',
    'speed': 'HSPA, LTE Cat4 150/50 Mbps',
    'features': 'Geo-tagging, touch focus, face detection',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 2100 ',
    '_4g_bands': 'LTE band 40(2300)'
  },
  {
    'DeviceName': 'Panasonic Eluga Turbo',
    'Brand': 'Panasonic',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, January',
    'status': 'Available. Released 2016, January',
    'dimensions': '142.4 x 71.2 x 6.9 mm (5.61 x 2.80 x 0.27 in)',
    'weight': '145 g (5.11 oz)',
    'sim': 'Dual SIM',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~68.0% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'display_c': '- FitHome UI ',
    'card_slot': 'microSD, up to 32 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 a/b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio, RDS',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/WAV/eAAC player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Non-removable Li-Ion 2350 mAh battery',
    'colors': 'Marine Blue, Champagne Gold, Rose Gold',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Octa-core',
    'internal': '32 GB, 3 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '13 MP, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP',
    'speed': 'HSPA, LTE Cat4 150/50 Mbps',
    'features': 'Geo-tagging, touch focus, face detection, HDR, panorama',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 3(1800), 5(850), 40(2300)'
  },
  {
    'DeviceName': 'Panasonic T50',
    'Brand': 'Panasonic',
    'technology': 'GSM / HSPA',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, March',
    'status': 'Available. Released 2016, March',
    'dimensions': '131.7 x 66.3 x 8.8 mm (5.19 x 2.61 x 0.35 in)',
    'weight': '-',
    'sim': 'Dual SIM',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '4.5 inches (~63.9% screen-to-body ratio)',
    'resolution': '480 x 854 pixels (~218 ppi pixel density)',
    'display_c': '- Sail UI',
    'card_slot': 'microSD, up to 32 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.0',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/WAV/eAAC player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Li-Ion 1600 mAh battery',
    'colors': 'Midnight Blue, Rose Gold, Champagne Gold',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Quad-core 1.3 GHz',
    'internal': '8 GB, 1 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '5 MP, autofocus, LED flash',
    'video': '720p@30fps',
    'secondary': '2 MP',
    'speed': 'HSPA',
    'features': 'Geo-tagging, touch focus, face detection',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 2100 '
  },
  {
    'DeviceName': 'Plum Might Plus II',
    'Brand': 'Plum',
    'technology': 'GSM / HSPA',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, March',
    'status': 'Available. Released 2016, March',
    'dimensions': '145.9 x 72.9 x 8.9 mm (5.74 x 2.87 x 0.35 in)',
    'weight': '116.2 g (4.09 oz)',
    'sim': 'Dual SIM (Micro-SIM/ Mini-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~64.8% screen-to-body ratio)',
    'resolution': '480 x 854 pixels (~196 ppi pixel density)',
    'card_slot': 'microSD, up to 64 GB',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email',
    'browser': 'HTML',
    'java': 'No',
    'features_c': '- MP4/DivX/Xvid/H.264 player\r\n  - WAV/MP3/AAC player\r\n  - Photo/video editor',
    'battery_c': 'Removable Li-Po 2000 mAh battery',
    'stand_by': 'Up to 900 h (2G) / Up to 750 h (3G)',
    'talk_time': 'Up to 24 h (2G) / Up to 14 h (3G)',
    'colors': 'Black, White',
    'sensors': 'Accelerometer, gyro, proximity',
    'cpu': 'Quad-core 1.2 GHz Cortex-A7',
    'internal': '4 GB, 512 MB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '8 MP, f/2.8, autofocus, LED flash',
    'video': '720p@30fps',
    'secondary': '2 MP',
    'speed': 'HSPA 21.1/5.76 Mbps',
    'chipset': 'Mediatek MT6580M',
    'features': 'Geo-tagging, face/smile detection, panorama, HDR',
    'gpu': 'Mali-400',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 1700 / 1900 / 2100 '
  },
  {
    'DeviceName': 'BLU Life Mark',
    'Brand': 'BLU',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, March',
    'status': 'Available. Released 2016, March',
    'dimensions': '142.4 x 72 x 9.5 mm (5.61 x 2.83 x 0.37 in)',
    'weight': '150 g (5.29 oz)',
    'sim': 'Dual SIM (Micro-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~67.2% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'card_slot': 'microSD, up to 64 GB',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Yes',
    'bluetooth': 'v4.0',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/eAAC+/WAV/Flac player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Removable Li-Po 2300 mAh battery',
    'stand_by': 'Up to 715 h (2G) / Up to 615 h (3G)',
    'talk_time': 'Up to 25 h (2G) / Up to 15 h (3G)',
    'colors': 'Gold, Grey, White',
    'sensors': 'Fingerprint, accelerometer, proximity, compass',
    'cpu': 'Quad-core 1.3 GHz Cortex-A53',
    'internal': '16 GB, 2 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '13 MP, f/2.0, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP',
    'speed': 'HSPA 42.2/11.5 Mbps, LTE Cat4 150/50 Mbps',
    'chipset': 'Mediatek MT6735',
    'features': '1/3\' sensor size, geo-tagging, touch focus, face/smile detection, panorama, HDR',
    'gpu': 'Mali-T720',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 2100 ',
    '_4g_bands': 'LTE band 3(1800), 7(2600), 20(800), 38(2600), 40(2300) - L0030EE'
  },
  {
    'DeviceName': 'BLU Studio One',
    'Brand': 'BLU',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Available. Released 2016, February',
    'dimensions': '141.5 x 71 x 7.6 mm (5.57 x 2.80 x 0.30 in)',
    'weight': '147 g (5.19 oz)',
    'sim': 'Dual SIM (Micro-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~68.6% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'card_slot': 'microSD, up to 64 GB',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Yes',
    'bluetooth': 'v4.0',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/eAAC+/WAV/Flac player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Non-removable Li-Po 2450 mAh battery',
    'stand_by': 'Up to 725 h (2G) / Up to 625 h (3G)',
    'talk_time': 'Up to 26 h (2G) / Up to 16 h (3G)',
    'colors': 'Black, Grey, White, Gold',
    'sensors': 'Accelerometer, proximity, compass',
    'cpu': 'Quad-core 1.3 GHz Cortex-A53',
    'internal': '16 GB, 2 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '13 MP, f/2.0, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP',
    'speed': 'HSPA 42.2/11.5 Mbps, LTE Cat4 150/50 Mbps',
    'network_c': 'LTE band 3(1800), 7(2600), 20(800), 38(2600), 40(2300) - S0110EE',
    'chipset': 'Mediatek MT6735',
    'features': '1/3\' sensor size, geo-tagging, touch focus, face/smile detection, panorama, HDR',
    'gpu': 'Mali-T720',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 1700(AWS) / 1900 / 2100 - S0110UU',
    '_4g_bands': 'LTE band 2(1900), 4(1700/2100), 7(2600), 12(700), 17(700) - S0110UU'
  },
  {
    'DeviceName': 'BLU Studio One Plus',
    'Brand': 'BLU',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Available. Released 2016, February',
    'dimensions': '143.5 x 71.2 x 8.7 mm (5.65 x 2.80 x 0.34 in)',
    'weight': '175 g (6.17 oz)',
    'sim': 'Dual SIM (Micro-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.5 inches (~81.6% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~401 ppi pixel density)',
    'card_slot': 'microSD, up to 64 GB',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Yes',
    'bluetooth': 'v4.0',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/eAAC+/WAV/Flac player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Non-removable Li-Po 3200 mAh battery',
    'stand_by': 'Up to 750 h (2G) / Up to 650 h (3G)',
    'talk_time': 'Up to 28 h (2G) / Up to 18 h (3G)',
    'colors': 'Grey, Gold, Silver',
    'sensors': 'Accelerometer, proximity, compass',
    'cpu': 'Octa-core 1.3 GHz Cortex-A53',
    'internal': '16 GB, 2 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '13 MP, f/2.0, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP',
    'speed': 'HSPA 42.2/11.5 Mbps, LTE Cat4 150/50 Mbps',
    'chipset': 'Mediatek MT6753',
    'features': '1/3\' sensor size, geo-tagging, touch focus, face/smile detection, panorama, HDR',
    'gpu': 'Mali-T720',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 1700(AWS) / 1900 / 2100 - S0130UU',
    '_4g_bands': 'LTE band 2(1900), 4(1700/2100), 7(2600), 12(700), 17(700) - S0130UU'
  },
  {
    'DeviceName': 'BLU Dash X Plus LTE',
    'Brand': 'BLU',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, March',
    'status': 'Available. Released 2016, March',
    'dimensions': '158.8 x 77.7 x 10.2 mm (6.25 x 3.06 x 0.40 in)',
    'weight': '190 g (6.70 oz)',
    'sim': 'Dual SIM (Micro-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.5 inches (~67.6% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~267 ppi pixel density)',
    'card_slot': 'microSD, up to 64 GB',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0',
    'gps': 'Yes, with A-GPS',
    'radio': 'Stereo FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP3/AAC/WMA/WAV player\r\n  - MP4/DivX/XviD/WMV/H.264 player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Removable Li-Po 2750 mAh battery',
    'stand_by': 'Up to 700 h (2G) / Up to 625 h (3G)',
    'talk_time': 'Up to 25 h (2G) / Up to 16 h (3G)',
    'colors': 'Black, Gold, White',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Quad-core 1.0 GHz Cortex-A53',
    'internal': '8 GB, 1 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '8 MP, f/2.4, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP, LED flash',
    'speed': 'HSPA 42.2/11.5 Mbps, LTE Cat4 150/50 Mbps',
    'chipset': 'Mediatek MT6735',
    'features': '1/3.2\' sensor size, geo-tagging, touch focus, face/smile detection',
    'gpu': 'Mali-T720',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 1700(AWS) / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 2(1900), 3(1800), 4(1700/2100), 5(850), 7(2600), 12(700), 17(700)'
  },
  {
    'DeviceName': 'BLU Energy X LTE',
    'Brand': 'BLU',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, March',
    'status': 'Available. Released 2016, March',
    'dimensions': '143 x 69.9 x 8.5 mm (5.63 x 2.75 x 0.33 in)',
    'weight': '183 g (6.46 oz)',
    'sim': 'Dual SIM',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~68.9% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'card_slot': 'microSD, up to 64 GB',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes, with stereo speakers',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - MP4/H.264 player\r\n  - MP3/WAV/eAAC+ player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Non-removable Li-Po 4000 mAh battery',
    'stand_by': 'Up to 800 h (2G) / Up to 725 h (3G)',
    'talk_time': 'Up to 52 h (2G) / Up to 38 h (3G)',
    'colors': 'Gold, Grey',
    'sensors': 'Accelerometer, proximity, compass',
    'cpu': 'Quad-core 1.3 GHz Cortex-A53',
    'internal': '16 GB, 1 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '8 MP, f/2.4, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP',
    'speed': 'HSPA 42.2/11.5 Mbps, LTE Cat4 150/50 Mbps',
    'chipset': 'Mediatek MT6735',
    'features': '1/4 sensor size, geo-tagging, touch focus, face/smile detection, panorama, HDR',
    'gpu': 'Mali-T720',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 1700(AWS) / 1900 ',
    '_4g_bands': 'LTE band 2(1900), 4(1700/2100), 7(2600)'
  },
  {
    'DeviceName': 'QMobile Noir Z12',
    'Brand': 'QMobile',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Available. Released 2016, February',
    'dimensions': '151.9 x 74.6 x 6.9 mm (5.98 x 2.94 x 0.27 in)',
    'weight': '147 g (5.19 oz)',
    'sim': 'Dual SIM (Nano-SIM/ Micro-SIM, dual stand-by)',
    'type': 'AMOLED capacitive touchscreen, 16M colors',
    'size': '5.5 inches (~73.6% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~267 ppi pixel density)',
    'display_c': '- Amigo OS 3.1',
    'card_slot': 'microSD, up to 128 GB (uses SIM 2 slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'v2.0, Type-C 1.0 reversible connector',
    'messaging': 'SMS (threaded view), MMS, Email, Push Email',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - MP4/H.264 player\r\n  - MP3/WAV/eAAC+ player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Non-removable Li-Ion 3150 mAh battery',
    'colors': 'Gold',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Octa-core 1.3 GHz Cortex-A53',
    'internal': '32 GB, 3 GB RAM',
    'os': 'Android OS, v5.1.1 (Lollipop)',
    'primary_': '13 MP, f/2.0, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP',
    'speed': 'HSPA 42.2/11.5 Mbps, LTE Cat4 150/50 Mbps',
    'chipset': 'Mediatek MT6753',
    'features': 'Geo-tagging, touch focus, face detection',
    'gpu': 'Mali-T720MP3',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 ',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': ' HSDPA',
    '_4g_bands': ' LTE'
  },
  {
    'DeviceName': 'Apple iPad Pro 9.7',
    'Brand': 'Apple',
    'technology': 'GSM / CDMA / HSPA / EVDO / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, March',
    'status': 'Available. Released 2016, March',
    'dimensions': '240 x 169.5 x 6.1 mm (9.45 x 6.67 x 0.24 in)',
    'weight': '437 g (Wi-Fi) / 444 g (LTE) (15.66 oz)',
    'sim': 'Nano-SIM/ Electronic SIM card (e-SIM)',
    'type': 'LED-backlit IPS LCD, capacitive touchscreen, 16M colors',
    'size': '9.7 inches (~71.6% screen-to-body ratio)',
    'resolution': '1536 x 2048 pixels (~264 ppi pixel density)',
    'display_c': '- True-tone display',
    'card_slot': 'No',
    'alert_types': 'N/A',
    'loudspeaker_': 'Yes, with stereo speakers (4 speakers)',
    'wlan': 'Wi-Fi 802.11 a/b/g/n/ac, dual-band, hotspot',
    'bluetooth': 'v4.2, A2DP, EDR',
    'gps': 'Yes, with A-GPS, GLONASS (Wi&#8209;Fi + Cellular model only)',
    'radio': 'No',
    'usb': 'v2.0, reversible connector',
    'messaging': 'iMessage, Email, Push Email, IM',
    'browser': 'HTML5 (Safari)',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - Siri natural language commands and dictation\r\n  - iCloud cloud service\r\n  - MP3/WAV/AAX+/AIFF/Apple Lossless player\r\n  - MP4/H.264 player\r\n  - Audio/video/photo editor\r\n  - Document editor',
    'battery_c': 'Non-removable Li-Ion battery (27.9 Wh)',
    'talk_time': 'Up to 10 h (multimedia)',
    'colors': 'Silver, Gold, Space Gray, Rose Gold',
    'sensors': 'Fingerprint, accelerometer, gyro, compass, barometer',
    'cpu': 'Dual-core 2.16 GHz (Twister)',
    'internal': '32/128/256 GB, 2 GB RAM',
    'os': 'iOS 9.3',
    'body_c': '- Stylus',
    'primary_': '12 MP, f/2.2, 29mm, phase detection autofocus, dual-LED (dual tone) flash',
    'video': '2160p@30fps, 1080p@30/60fps, 1080p@120fps, 720p@240fps',
    'secondary': '5 MP, f/2.2, 31mm, 1080p@30fps, 720p@240fps, face detection, HDR, panorama',
    'speed': 'HSPA 42.2/5.76 Mbps, LTE Cat4 150/50 Mbps, EV-DO Rev.A 3.1 Mbps',
    'network_c': 'CDMA2000 1xEV-DO ',
    'chipset': 'Apple A9X',
    'features': '1/3\' sensor size, 1.22 Âµm pixel size, geo-tagging, simultaneous 4K video and 8MP image recording, touch focus, face/smile detection, HDR (photo/panorama)',
    'protection': 'Scratch-resistant glass, oleophobic coating',
    'gpu': 'PowerVR Series 7 (12-core graphics)',
    'multitouch': 'Yes',
    'nfc': 'NFC',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 ',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 800 / 850 / 900 / 1700(AWS) / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 2(1900), 3(1800), 4(1700/2100), 5(850), 7(2600), 8(900), 12(700), 13(700), 17(700), 18(800), 19(800), 20(800), 25(1900), 26(850), 27(800), 28(700), 29(700), 30(2300), 38(2600), 39(1900), 40(2300), 41(2500)'
  },
  {
    'DeviceName': 'Huawei P9 Lite',
    'Brand': 'Huawei',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, April',
    'status': 'Coming soon. Exp. release 2016, April',
    'dimensions': '-',
    'weight': '-',
    'sim': 'Dual SIM (Nano-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.2 inches',
    'resolution': '1080 x 1920 pixels (~424 ppi pixel density)',
    'display_c': '- Emotion UI 4.1',
    'card_slot': 'microSD, up to 128 GB (uses SIM 2 slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 a/b/g/n, dual-band, DLNA, WiFi Direct, hotspot',
    'bluetooth': 'v4.1, A2DP, LE',
    'gps': 'Yes, with A-GPS, GLONASS/ BDS (market dependant)',
    'radio': 'To be confirmed',
    'usb': 'Type-C 1.0 reversible connector',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - MP4/H.264 player\r\n  - MP3/eAAC+/WAV/Flac player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Non-removable 3000 mAh battery',
    'colors': 'Silver, Gold',
    'sensors': 'Fingerprint, accelerometer, proximity, compass',
    'cpu': 'Octa-core',
    'internal': '16 GB, 2/3 GB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'primary_': '13 MP, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '8 MP',
    'speed': 'HSPA 42.2/5.76 Mbps, LTE Cat6 300/50 Mbps',
    'chipset': 'HiSilicon Kirin 650',
    'features': 'Geo-tagging, touch focus, face/smile detection, panorama, HDR',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 ',
    '_4g_bands': ' LTE'
  },
  {
    'DeviceName': 'Icemobile Mash',
    'Brand': 'Icemobile',
    'technology': 'GSM',
    'gprs': 'Yes',
    'edge': 'No',
    'announced': '2016, March',
    'status': 'Available. Released 2016, March',
    'dimensions': '110 x 64 x 13.5 mm (4.33 x 2.52 x 0.53 in)',
    'weight': '-',
    'sim': 'Dual SIM',
    'type': 'TFT',
    'size': '2.2 inches (~21.3% screen-to-body ratio)',
    'resolution': '320 x 240 pixels (~182 ppi pixel density)',
    'card_slot': 'microSD, up to 16 GB (dedicated slot)',
    'phonebook': '300 entries',
    'call_records': '20 entries',
    'alert_types': 'Vibration, MP3, polyphonic ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'No',
    'bluetooth': 'Yes',
    'gps': 'No',
    'radio': 'FM radio',
    'usb': 'microUSB',
    'messaging': 'SMS',
    'browser': 'WAP',
    'games': 'No',
    'java': 'No',
    'features_c': '- MP4/H.263 player\r\n  - MP3 player',
    'battery_c': 'Removable Li-Ion 800 mAh battery',
    'stand_by': 'Up to 150 h',
    'talk_time': 'Up to 3 h',
    'colors': 'White, Black, Red, Gold',
    'internal': '32 MB, 32 MB RAM',
    'keyboard': 'QWERTY',
    'primary_': 'VGA',
    'video': 'No',
    'secondary': 'No',
    'chipset': 'Spreadtrum 6531DA',
    'features': 'No',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes'
  },
  {
    'DeviceName': 'Oppo R9 Plus',
    'Brand': 'Oppo',
    'technology': 'GSM / CDMA / HSPA / EVDO / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, March',
    'status': 'Available. Released 2016, March',
    'dimensions': '163.1 x 80.8 x 7.4 mm (6.42 x 3.18 x 0.29 in)',
    'weight': '185 g (6.53 oz)',
    'sim': 'Dual SIM (Nano-SIM, dual stand-by)',
    'type': 'Capacitive touchscreen, 16M colors',
    'size': '6.0 inches (~75.3% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~367 ppi pixel density)',
    'display_c': '- Color OS 3.0',
    'card_slot': 'microSD, up to 128 GB (uses SIM 2 slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 a/b/g/n/ac, dual-band, WiFi Direct, hotspot',
    'bluetooth': 'v4.1',
    'gps': 'Yes, with A-GPS',
    'radio': 'No',
    'usb': 'microUSB v2.0, USB Host',
    'messaging': 'SMS (threaded view), MMS, Email, Push Email',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Fast battery charging\r\n  - Active noise cancellation with dedicated mic\r\n  - MP4/H.264 player\r\n  - MP3/WAV/eAAC+/FLAC player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Non-removable Li-Po 4120 mAh battery',
    'colors': 'Gold',
    'sensors': 'Fingerprint, accelerometer, gyro, proximity, compass',
    'cpu': 'Quad-core 1.8 GHz Cortex-A72 & quad-core 1.2 GHz Cortex-A53',
    'internal': '64/128 GB, 4 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '16 MP, f/2.0, phase detection autofocus, LED flash',
    'video': '2160p@30fps, 1080p@30fps',
    'secondary': '16 MP, f/2.0',
    'speed': 'HSPA, LTE',
    'network_c': 'CDMA2000 1xEV-DO & TD-SCDMA',
    'chipset': 'Qualcomm MSM8976 Snapdragon 652',
    'features': '1/2.8\' sensor size, geo-tagging, touch focus, face detection, panorama, HDR',
    'protection': 'Corning Gorilla Glass 4',
    'gpu': 'Adreno 510',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 5(850), 38(2600), 39(1900), 40(2300), 41(2500)'
  },
  {
    'DeviceName': 'LG K5',
    'Brand': 'LG',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, March',
    'status': 'Coming soon. Exp. release 2016, April',
    'dimensions': '145 x 71.6 x 8.9 mm (5.71 x 2.82 x 0.35 in)',
    'weight': '-',
    'sim': 'Single SIM (Micro-SIM) or Dual SIM (Micro-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~66.4% screen-to-body ratio)',
    'resolution': '480 x 854 pixels (~196 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.1, A2DP, LE',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/WAV/eAAC+/Flac player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Removable Li-Ion 1900 mAh battery',
    'colors': 'Gold, Silver, Titan',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Quad-core 1.3 GHz',
    'internal': '8 GB, 1 GB RAM',
    'os': 'Android OS, v5.1.1 (Lollipop)',
    'primary_': '5 MP, f/2.8, autofocus, LED flash',
    'video': 'Yes',
    'secondary': '2 MP, f/2.8',
    'speed': 'HSPA 21.1/5.76 Mbps, LTE Cat4 150/50 Mbps',
    'features': 'Geo-tagging, touch focus, face detection',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2 (dual-SIM model only)',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 7(2600), 8(900), 20(800)'
  },
  {
    'DeviceName': 'Samsung Galaxy S7 mini',
    'Brand': 'Samsung',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': 'Not announced yet',
    'status': 'Rumored',
    'dimensions': '9.9 mm thickness',
    'weight': '-',
    'sim': 'Single SIM (Nano-SIM) or Dual SIM (Nano-SIM, dual stand-by)',
    'type': 'Super AMOLED capacitive touchscreen, 16M colors',
    'size': '4.6 inches',
    'resolution': '1080 x 1920 pixels (~479 ppi pixel density)',
    'display_c': '- Always-on display\r\n  - TouchWiz UI',
    'card_slot': 'microSD, up to 200 GB (dedicated slot) - single-SIM model\r\nmicroSD, up to 200 GB (uses SIM 2 slot) - dual-SIM model',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 a/b/g/n/ac, dual-band, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.2, A2DP, LE, apt-X',
    'gps': 'Yes, with A-GPS, GLONASS, BDS',
    'radio': 'No',
    'usb': 'microUSB v2.0, USB Host',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- ANT+ support\r\n  - S-Voice natural language commands and dictation\r\n  - OneDrive (115 GB cloud storage)\r\n  - Active noise cancellation with dedicated mic\r\n  - MP4/DivX/XviD/WMV/H.264 player\r\n  - MP3/WAV/WMA/eAAC+/FLAC player\r\n  - Photo/video editor\r\n  - Document editor',
    'colors': 'Black, White, Gold, Silver',
    'sensors': 'Fingerprint, accelerometer, gyro, proximity, compass',
    'cpu': 'Dual-core 2.15 GHz Kryo & dual-core 1.6 GHz Kryo\r\nQuad-core 2.3 GHz Mongoose + quad-core 1.6 GHz Cortex-A53',
    'internal': '32/64 GB, 3 GB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'body_c': '- Samsung Pay (Visa, MasterCard certified)\r\n  - IP68 certified - dust proof and water resistant over 1.5 meter and 30 minutes',
    'primary_': '12 MP, f/1.7, 26mm, phase detection autofocus, OIS, LED flash',
    'video': '2160p@30fps, 1080p@60fps, 720p@240fps, HDR, dual-video rec.',
    'secondary': '5 MP, f/1.7, 22mm, dual video call, Auto HDR',
    'speed': 'HSPA 42.2/5.76 Mbps, LTE Cat4 150/50 Mbps',
    'chipset': 'Qualcomm MSM8996 Snapdragon 820\r\nExynos 8890 Octa',
    'features': '1/2.6\' sensor size, 1.4 Âµm pixel size, geo-tagging, simultaneous 4K video and 9MP image recording, touch focus, face/smile detection, Auto HDR, panorama',
    'protection': 'Corning Gorilla Glass 4',
    'gpu': 'Adreno 530\r\nMali-T880 MP12',
    'multitouch': 'Yes',
    'nfc': 'Yes',
    'build': 'Corning Gorilla Glass 4 back panel',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2 (dual-SIM model only)',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 ',
    '_4g_bands': ' LTE'
  },
  {
    'DeviceName': 'BLU Life XL',
    'Brand': 'BLU',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Class 12',
    'edge': 'Class 12',
    'announced': '2016, January',
    'status': 'Available. Released 2016, January',
    'dimensions': '155.4 x 79.3 x 8.5 mm (6.12 x 3.12 x 0.33 in)',
    'weight': '168 g (5.93 oz)',
    'sim': 'Dual SIM (Micro-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.5 inches (~67.7% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~267 ppi pixel density)',
    'card_slot': 'microSD, up to 64 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes, with stereo speakers',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0, USB Host',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/eAAC+/WAV player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Removable Li-Po 2820 mAh battery',
    'stand_by': 'Up to 650 h (2G) / Up to 550 h (3G)',
    'talk_time': 'Up to 28 h (2G) / Up to 20 h (3G)',
    'colors': 'Black, White',
    'sensors': 'Accelerometer, proximity, compass',
    'cpu': 'Octa-core 1.4 GHz Cortex-A7\r\nQuad-core 1.2 GHz Cortex-A53',
    'internal': '8/16 GB, 1/2 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '13 MP, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP',
    'speed': 'HSPA 42.2/11.5 Mbps, LTE Cat4 150/50 Mbps',
    'network_c': 'HSDPA 850 / 1700(AWS) / 1900 / 2100 - L0050UU/L0051UU',
    'chipset': 'MediaTek MT6592M\r\nQualcomm MSM8916 Snapdragon 410',
    'features': 'Geo-tagging, touch focus, face/smile detection, panorama, HDR',
    'gpu': 'Mali-450MP4\r\nAdreno 306',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 1700(AWS) / 1900 - L050U',
    '_4g_bands': 'LTE band 2(1900), 4(1700/2100), 7(2600), 12(700), 17(700)'
  },
  {
    'DeviceName': 'LG X cam',
    'Brand': 'LG',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Coming soon. Exp. release 2016, April',
    'dimensions': '147.5 x 73.6 x 6.9 mm (5.81 x 2.90 x 0.27 in)',
    'weight': '118 g (4.16 oz)',
    'sim': 'Yes',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.2 inches (~68.7% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~424 ppi pixel density)',
    'card_slot': 'microSD',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Yes',
    'bluetooth': 'Yes',
    'gps': 'Yes, with A-GPS, GLONASS',
    'radio': 'To be confirmed',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/WAV/eAAC+/Flac player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Li-Ion 2520 mAh battery',
    'colors': 'Titan Silver, White, Gold, Pink Gold',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Octa-core 1.14 GHz',
    'internal': '16 GB, 2 GB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'primary_': '13 MP or 5 MP, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '8 MP',
    'speed': 'HSPA, LTE Cat4 150/50 Mbps',
    'features': 'Geo-tagging, touch focus, face detection, panorama',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 ',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 7(2600), 8(900), 20(800)'
  },
  {
    'DeviceName': 'LG X screen',
    'Brand': 'LG',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Available. Released 2016, March',
    'dimensions': '142.6 x 71.8 x 7.1 mm (5.61 x 2.83 x 0.28 in)',
    'weight': '-',
    'sim': 'Yes',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '4.93 inches (~65.4% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~298 ppi pixel density)',
    'display_c': '- Secondary display, 80 x 520 pixels, 1.76 inches',
    'card_slot': 'microSD',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Yes',
    'bluetooth': 'Yes',
    'gps': 'Yes, with A-GPS, GLONASS',
    'radio': 'To be confirmed',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/WAV/eAAC+/Flac player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Li-Ion 2300 mAh battery',
    'colors': 'Black, White, Pink Gold',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Quad-core 1.2 GHz',
    'internal': '16 GB, 2 GB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'primary_': '13 MP, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '8 MP',
    'speed': 'HSPA, LTE Cat4 150/50 Mbps',
    'features': 'Geo-tagging, touch focus, face detection, panorama',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 ',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 7(2600), 8(900), 20(800)'
  },
  {
    'DeviceName': 'Yezz Andy 5.5M LTE VR',
    'Brand': 'Yezz',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, January',
    'status': 'Available. Released 2016, March',
    'dimensions': '157.4 x 78 x 9 mm (6.20 x 3.07 x 0.35 in)',
    'weight': '165 g (5.82 oz)',
    'sim': 'Dual SIM (Micro-SIM)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.5 inches (~67.9% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~267 ppi pixel density)',
    'card_slot': 'microSD, up to 64 GB',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0, LE',
    'gps': 'Yes, with A-GPS',
    'radio': 'Stereo FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/eAAC+/WAV/FLAC player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Removable Li-Ion 2400 mAh battery',
    'stand_by': 'Up to 240 h (2G) / Up to 200 h (3G)',
    'talk_time': 'Up to 17 h 40 min (2G) / Up to 15 h (3G)',
    'colors': 'Black',
    'sensors': 'Accelerometer, gyro, proximity',
    'cpu': 'Quad-core 1.0 GHz Cortex-A53',
    'internal': '8 GB, 1 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '13 MP, LED flash',
    'video': '720p@30fps',
    'secondary': '5 MP',
    'speed': 'HSPA 42.2/11.5 Mbps, LTE Cat4 150/50 Mbps',
    'chipset': 'Mediatek MT6735',
    'features': 'Geo-tagging, panorama',
    'gpu': 'Mali-T720',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 1900 - AM55ML194',
    '_4g_bands': 'LTE band 2(1900), 4(1700/2100), 7(2600), 17(700) - AM55ML194'
  },
  {
    'DeviceName': 'BLU Studio 5.5 HD',
    'Brand': 'BLU',
    'technology': 'GSM / HSPA',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, March',
    'status': 'Available. Released 2016, March',
    'dimensions': '153.8 x 77.4 x 9.1 mm (6.06 x 3.05 x 0.36 in)',
    'weight': '183 g (6.46 oz)',
    'sim': 'Dual SIM (Micro-SIM/ Mini-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.5 inches (~70.1% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~267 ppi pixel density)',
    'card_slot': 'microSD, up to 64 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0',
    'gps': 'Yes, with A-GPS',
    'radio': 'Stereo FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP3/AAC/WMA/WAV player\r\n  - MP4/DivX/XviD/WMV/H.264 player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Removable Li-Po 2500 mAh battery',
    'stand_by': 'Up to 700 h (2G) / Up to 650 h (3G)',
    'talk_time': 'Up to 26 h (2G) / Up to 16 h (3G)',
    'colors': 'Black, White, Gold',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Quad-core 1.3 GHz Cortex-A7',
    'internal': '8 GB, 1 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '5 MP, f/2.4, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP',
    'speed': 'HSPA 21.1/5.76 Mbps',
    'network_c': 'HSDPA 850 / 1700(AWS) / 1900 - S150U',
    'features': '1/4 sensor size, geo-tagging, touch focus',
    'gpu': 'Mali-400',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 1900 / 2100 - S150L'
  },
  {
    'DeviceName': 'Lava Iris Fuel F2',
    'Brand': 'Lava',
    'technology': 'GSM / HSPA',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, March',
    'status': 'Available. Released 2016, March',
    'dimensions': '142.5 x 72.5 x 10.5 mm (5.61 x 2.85 x 0.41 in)',
    'weight': '-',
    'sim': 'Dual SIM (Micro-SIM, dual stand-by)',
    'type': 'LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~66.7% screen-to-body ratio)',
    'resolution': '480 x 854 pixels (~196 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v2.1, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'No',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - MP4/H.264 player\r\n  - MP3/WAV/AAC player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Non-removable Li-Po 3000 mAh battery',
    'colors': 'Black, White',
    'cpu': 'Quad-core 1.3 GHz Cortex-A7',
    'internal': '8 GB, 512 MB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '5MP, LED flash',
    'video': '720p@30fps',
    'secondary': '0.3 MP',
    'speed': 'HSPA',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 900 / 1800 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 2100 '
  },
  {
    'DeviceName': 'Huawei P9',
    'Brand': 'Huawei',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, April',
    'status': 'Coming soon. Exp. release 2016, April',
    'dimensions': '145 x 70.9 x 7 mm (5.71 x 2.79 x 0.28 in)',
    'weight': '144 g (5.08 oz)',
    'sim': 'Single SIM (Nano-SIM) or Dual SIM (Nano-SIM, dual stand-by)',
    'type': 'IPS-NEO LCD capacitive touchscreen, 16M colors',
    'size': '5.2 inches (~72.9% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~423 ppi pixel density)',
    'display_c': '- Emotion UI 4.1',
    'card_slot': 'microSD, up to 128 GB (uses SIM 2 slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 a/b/g/n/ac, dual-band, DLNA, WiFi Direct, hotspot',
    'bluetooth': 'v4.2, A2DP, LE',
    'gps': 'Yes, with A-GPS, GLONASS/ BDS (market dependant)',
    'radio': 'To be confirmed',
    'usb': 'Type-C 1.0 reversible connector',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - XviD/MP4/H.265 player\r\n  - MP3/eAAC+/WAV/Flac player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Non-removable Li-Ion 3000 mAh battery',
    'colors': 'Ceramic White, Haze Gold, Rose Gold, Titanium Grey, Mystic Silver, Prestige Gold',
    'sensors': 'Fingerprint, accelerometer, gyro, proximity, compass',
    'cpu': 'Quad-core 2.5 GHz Cortex-A72 & quad-core 1.8 GHz Cortex-A53',
    'internal': '32 GB, 3 GB RAM (EVA-L19/EVA-L09)\r\n64 GB, 4 GB RAM (EVA-L29)',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'primary_': 'Dual 12 MP, f/2.2, 27 mm, Leica optics, phase detection autofocus, dual-LED (dual tone) flash',
    'video': '1080p@30fps',
    'secondary': '8 MP, f/2.4, 1080p',
    'speed': 'HSPA 42.2/5.76 Mbps, LTE Cat6 300/50 Mbps',
    'network_c': 'LTE band 1(2100), 2(1900), 3(1800), 4(1700/2100), 5(850), 6(900), 7(2600), 8(900), 12(700), 17(700), 18(800), 19(800), 20(800), 26(850), 28(700), 38(2600), 39(1900), 40(2300) - EVA-L09',
    'chipset': 'HiSilicon Kirin 955',
    'features': '1.25 Âµm pixel size, geo-tagging, touch focus, face/smile detection, panorama, HDR',
    'protection': 'Corning Gorilla Glass 4',
    'gpu': 'Mali-T880 MP4',
    'multitouch': 'Yes',
    'nfc': 'Yes (EVA-L09 only)',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2 (dual-SIM model only)',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1700(AWS) / 1900 / 2100 - EVA-L19',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 4(1700/2100), 7(2600), 20(800), 38(2600), 39(1900), 40(2300), B41 - EVA-L19'
  },
  {
    'DeviceName': 'Meizu Pro 6',
    'Brand': 'Meizu',
    'technology': 'GSM / HSPA / EVDO / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, April',
    'status': 'Coming soon',
    'dimensions': '147.7 x 70.8 x 7.3 mm (5.81 x 2.79 x 0.29 in)',
    'weight': '160 g (5.64 oz)',
    'sim': 'Dual SIM (Nano-SIM, dual stand-by)',
    'type': 'Super AMOLED capacitive touchscreen, 16M colors',
    'size': '5.2 inches (~71.6% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~423 ppi pixel density)',
    'display_c': '- 3D Touch display\r\n  - Flyme 6.0',
    'card_slot': 'microSD, up to 128 GB (uses SIM 2 slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'sound_c': '- Hi-Fi audio',
    'wlan': 'Wi-Fi 802.11 a/b/g/n/ac, dual-band, WiFi Direct, hotspot',
    'bluetooth': 'v4.1, A2DP, LE',
    'gps': 'Yes, with A-GPS, GLONASS, BDS',
    'radio': 'No',
    'usb': 'v3.1, Type-C 1.0 reversible connector',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Fast battery charging\r\n  - Active noise cancellation with dedicated mic\r\n  - MP3/WAV/eAAC+/FLAC player\r\n  - MP4/H.265 player\r\n  - Document editor\r\n  - Photo/video editor',
    'battery_c': 'Non-removable Li-Ion 2560 mAh battery',
    'colors': 'Gray, Gold, Silver',
    'sensors': 'Fingerprint, accelerometer, gyro, proximity, compass, barometer',
    'cpu': '2.5 GHz dual-core Cortex-A72 & 2 GHz quad-core Cortex-A53 & 1.4 GHz quad-core Cortex-A53',
    'internal': '32/64 GB, 4 GB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'primary_': '21 MP, f/2.2, 31mm, phase detection & laser autofocus, ring LED (dual tone) flash',
    'video': 'Yes',
    'secondary': '5 MP, f/2.0',
    'speed': 'HSPA, LTE Cat6 300/50 Mbps',
    'network_c': 'CDMA2000 1xEV-DO & TD-SCDMA',
    'chipset': 'Mediatek Helio X25',
    'features': '1/2.4\' sensor size, geo-tagging, touch focus, face detection, HDR, panorama',
    'protection': 'Corning Gorilla Glass 4',
    'gpu': 'Mali-T880 MP4',
    'multitouch': 'Yes',
    'nfc': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 7(2600), 38(2600), 39(1900), 40(2300), 41(2500)'
  },
  {
    'DeviceName': 'vivo Xplay5 Elite',
    'Brand': 'vivo',
    'technology': 'GSM / CDMA / HSPA / EVDO / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, March',
    'status': 'Available. Released 2016, March',
    'dimensions': '153.5 x 76.2 x 7.6 mm (6.04 x 3.00 x 0.30 in)',
    'weight': '167.8 g (5.93 oz)',
    'sim': 'Dual SIM (Nano-SIM, dual stand-by)',
    'type': 'Super AMOLED capacitive touchscreen, 16M colors',
    'size': '5.43 inches (~69.5% screen-to-body ratio)',
    'resolution': '1440 x 2560 pixels (~541 ppi pixel density)',
    'display_c': '- Funtouch OS 2.6',
    'card_slot': 'No',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'sound_c': '- Hi-Fi 3.0',
    'wlan': 'Wi-Fi 802.11 a/b/g/n/ac, dual-band, WiFi Direct, hotspot',
    'bluetooth': 'v4.2, A2DP, LE',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0, USB On-The-Go',
    'messaging': 'SMS (threaded view), MMS, Email, Push Email',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Fast battery charging\r\n  - Active noise cancellation with dedicated mic\r\n  - MP4/H.264 player\r\n  - MP3/WAV/eAAC+/FLAC player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Non-removable Li-Ion 3600 mAh battery',
    'colors': 'Silver, Gold, Rose Gold',
    'sensors': 'Fingerprint, accelerometer, gyro, proximity, compass',
    'cpu': 'Dual-core 2.15 GHz Kryo & dual-core 1.6 GHz Kryo',
    'internal': '128 GB, 6 GB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'primary_': '16 MP, f/2.0, phase detection autofocus, dual-LED (dual tone) flash',
    'video': '2160p@30fps, 1080p@30fps',
    'secondary': '8 MP, f/2.4',
    'speed': 'HSPA 42.2/5.76 Mbps, LTE Cat6 300/50 Mbps',
    'network_c': ' TD-SCDMA',
    'chipset': 'Qualcomm MSM8996 Snapdragon 820',
    'features': '1/2.8\' sensor size, 1.12 Âµm pixel size, geo-tagging, touch focus, face detection, panorama, HDR',
    'gpu': 'Adreno 530',
    'multitouch': 'Yes',
    'nfc': 'Yes',
    '_2g_bands': 'GSM 900 / 1800 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 2(1900), 3(1800), 4(1700/2100), 5(850), 7(2600), 8(900), 38(2600), 39(1900), 40(2300), 41(2500)'
  },
  {
    'DeviceName': 'Apple iPhone SE',
    'Brand': 'Apple',
    'technology': 'GSM / CDMA / HSPA / EVDO / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, March',
    'status': 'Available. Released 2016, March',
    'dimensions': '123.8 x 58.6 x 7.6 mm (4.87 x 2.31 x 0.30 in)',
    'weight': '113 g (3.99 oz)',
    'sim': 'Nano-SIM',
    'type': 'LED-backlit IPS LCD, capacitive touchscreen, 16M colors',
    'size': '4.0 inches (~60.8% screen-to-body ratio)',
    'resolution': '640 x 1136 pixels (~326 ppi pixel density)',
    'card_slot': 'No',
    'alert_types': 'Vibration, proprietary ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 a/b/g/n/ac, hotspot',
    'bluetooth': 'v4.2, A2DP, LE',
    'gps': 'Yes, with A-GPS, GLONASS',
    'radio': 'No',
    'usb': 'v2.0, reversible connector',
    'messaging': 'iMessage, SMS (threaded view), MMS, Email, Push Email',
    'browser': 'HTML5 (Safari)',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - Siri natural language commands and dictation\r\n  - iCloud cloud service\r\n  - MP3/WAV/AAX+/AIFF/Apple Lossless player\r\n  - MP4/H.264 player\r\n  - Audio/video/photo editor\r\n  - Document editor',
    'battery_c': 'Non-removable Li-Po 1624 mAh battery (6.21 Wh)',
    'stand_by': 'Up to 240 h (2G) / Up to 240 h (3G)',
    'talk_time': 'Up to 14 h (3G)',
    'colors': 'Space Gray, Silver, Gold, Rose Gold',
    'sar_us': '  1.17 W/kg (head) &nbsp; &nbsp; 1.19 W/kg (body) &nbsp; &nbsp; ',
    'sar_eu': '  0.97 W/kg (head) &nbsp; &nbsp; 0.99 W/kg (body) &nbsp; &nbsp; ',
    'sensors': 'Fingerprint, accelerometer, gyro, proximity, compass',
    'cpu': 'Dual-core 1.84 GHz Twister',
    'internal': '16/64 GB, 2 GB RAM',
    'os': 'iOS 9.3',
    'body_c': '- Apple Pay (Visa, MasterCard, AMEX certified)',
    'primary_': '12 MP, f/2.2, 29mm, phase detection autofocus, dual-LED (dual tone) flash, check quality',
    'video': '2160p@30fps, 1080p@30/60fps, 1080p@120fps, 720p@240fps, check quality',
    'secondary': '1.2 MP, f/2.4, 31mm, 720p@30fps, face detection, HDR, FaceTime over Wi-Fi or Cellular',
    'speed': 'HSPA, LTE Cat4 150/50 Mbps',
    'network_c': 'LTE band 1(2100), 2(1900), 3(1800), 4(1700/2100), 5(850), 7(2600), 8(900), 12(700), 17(700), 18(800), 19(800), 20(800), 25(1900), 26(850), 28(700), 38(2600), 39(1900), 40(2300), 41(2500) - A1723',
    'chipset': 'Apple A9',
    'features': '1/3\' sensor size, 1.22 Âµm pixel size, geo-tagging, simultaneous 4K video and 8MP image recording, touch focus, face/smile detection, HDR (photo/panorama)',
    'music_play': 'Up to 50 h',
    'gpu': 'PowerVR GT7600 (six-core graphics)',
    'multitouch': 'Yes',
    'loudspeaker': '  Voice 66dB / Noise 65dB / Ring 69dB    ',
    'audio_quality': '  Noise -93.0dB / Crosstalk -92.9dB',
    'nfc': 'Yes (Apple Pay only)',
    'camera': '  Photo / Video',
    'display': '  Contrast ratio: 804:1 (nominal), 3.681 (sunlight)',
    'performance': '  Basemark OS II 2.0: 2163',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - A1662, A1723',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 800 / 850 / 900 / 1700(AWS) / 1900 / 2100 - A1662, A1723',
    '_4g_bands': 'LTE band 1(2100), 2(1900), 3(1800), 4(1700/2100), 5(850), 8(900), 12(700), 13(700), 17(700), 18(800), 19(800), 20(800), 25(1900), 26(850), 29(700) - A1662'
  },
  {
    'DeviceName': 'Lenovo ZUK Z1 mini',
    'Brand': 'Lenovo',
    'technology': 'GSM / CDMA / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': 'Exp. announcement 2016, Q1',
    'status': 'Rumored. Exp. release 2016, Q2',
    'dimensions': '-',
    'weight': '-',
    'sim': 'Dual SIM (Micro-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '4.7 inches',
    'resolution': '720 x 1280 pixels (~312 ppi pixel density)',
    'card_slot': 'No',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0',
    'gps': 'Yes, with A-GPS, GLONASS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - MP4/H.264 player\r\n  - MP3/WAV/eAAC+/Flac player\r\n  - Photo/video editor\r\n  - Document viewer',
    'colors': 'White, Black',
    'sensors': 'Fingerprint, accelerometer, proximity',
    'cpu': 'Octa-core 2.0 GHz Cortex-A53',
    'internal': '16 GB, 2 GB RAM\r\n32 GB, 3 GB RAM',
    'os': 'Android OS, v5.1.1 (Lollipop)',
    'primary_': '8 MP, autofocus, LED flash',
    'video': 'Yes',
    'secondary': 'Yes',
    'speed': 'HSPA, LTE Cat4 150/50 Mbps',
    'network_c': ' TD-SCDMA',
    'chipset': 'Mediatek MT6755 Helio P10',
    'features': 'Geo-tagging, touch focus, face detection, panorama',
    'gpu': 'Mali-T860MP2',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 7(2600), 38(2600), 39(1900), 40(2300), 41(2500)'
  },
  {
    'DeviceName': 'Oppo F1 Plus',
    'Brand': 'Oppo',
    'technology': 'GSM / CDMA / HSPA / EVDO / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, March',
    'status': 'Available. Released 2016, March',
    'dimensions': '151.8 x 74.3 x 6.6 mm (5.98 x 2.93 x 0.26 in)',
    'weight': '145 g (5.11 oz)',
    'sim': 'Dual SIM (Nano-SIM, dual stand-by)',
    'type': 'AMOLED capacitive touchscreen, 16M colors',
    'size': '5.5 inches (~73.9% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~401 ppi pixel density)',
    'display_c': '- Color OS 3.0',
    'card_slot': 'microSD, up to 128 GB (uses SIM 2 slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 a/b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0',
    'gps': 'Yes, with A-GPS',
    'radio': 'No',
    'usb': 'microUSB v2.0, USB Host',
    'messaging': 'SMS (threaded view), MMS, Email, Push Email',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Fast battery charging\r\n  - Active noise cancellation with dedicated mic\r\n  - MP4/H.264 player\r\n  - MP3/WAV/eAAC+/FLAC player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Non-removable Li-Po 2850 mAh battery',
    'colors': 'Gold, Rose Gold',
    'sensors': 'Fingerprint, accelerometer, proximity, compass',
    'cpu': 'Octa-core 2.0 GHz Cortex-A53',
    'internal': '64 GB, 4 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '13 MP, f/2.2, phase detection autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '16 MP, f/2.0',
    'speed': 'HSPA 42.2/5.76 Mbps, LTE Cat6 300/50 Mbps',
    'network_c': 'LTE band 1(2100), 3(1800), 5(850), 7(2600), 8(900), 38(2600), 40(2300), 41(2500) - India',
    'chipset': 'Mediatek MT6755 Helio P10',
    'features': 'Geo-tagging, touch focus, face detection, panorama, HDR',
    'protection': 'Corning Gorilla Glass 4',
    'gpu': 'Mali-T860MP2',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 5(850), 38(2600), 39(1900), 40(2300), 41(2500)'
  },
  {
    'DeviceName': 'vivo Xplay5',
    'Brand': 'vivo',
    'technology': 'GSM / CDMA / HSPA / EVDO / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, March',
    'status': 'Available. Released 2016, March',
    'dimensions': '153.5 x 76.2 x 7.6 mm (6.04 x 3.00 x 0.30 in)',
    'weight': '167.8 g (5.93 oz)',
    'sim': 'Dual SIM (Nano-SIM, dual stand-by)',
    'type': 'Super AMOLED capacitive touchscreen, 16M colors',
    'size': '5.43 inches (~69.5% screen-to-body ratio)',
    'resolution': '1440 x 2560 pixels (~541 ppi pixel density)',
    'display_c': '- Funtouch OS 2.5.1',
    'card_slot': 'No',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'sound_c': '- Hi-Fi 3.0',
    'wlan': 'Wi-Fi 802.11 a/b/g/n/ac, dual-band, WiFi Direct, hotspot',
    'bluetooth': 'v4.0, A2DP, LE',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0, USB On-The-Go',
    'messaging': 'SMS (threaded view), MMS, Email, Push Email',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - MP4/H.264 player\r\n  - MP3/WAV/eAAC+/FLAC player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Non-removable Li-Ion 3600 mAh battery',
    'colors': 'Silver, Gold, Rose Gold',
    'sensors': 'Fingerprint, accelerometer, gyro, proximity, compass',
    'cpu': 'Quad-core 1.8 GHz Cortex-A72 & quad-core 1.4 GHz Cortex-A53',
    'internal': '128 GB, 4 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '16 MP, f/2.0, phase detection autofocus, dual-LED (dual tone) flash',
    'video': '2160p@30fps, 1080p@30fps',
    'secondary': '8 MP, f/2.4',
    'speed': 'HSPA 42.2/5.76 Mbps, LTE Cat6 300/50 Mbps',
    'network_c': ' TD-SCDMA',
    'chipset': 'Qualcomm MSM8976 Snapdragon 652',
    'features': '1/2.8\' sensor size, 1.12 Âµm pixel size, geo-tagging, touch focus, face detection, panorama, HDR',
    'gpu': 'Adreno 510',
    'multitouch': 'Yes',
    'nfc': 'Yes',
    '_2g_bands': 'GSM 900 / 1800 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 2(1900), 3(1800), 4(1700/2100), 5(850), 7(2600), 8(900), 38(2600), 39(1900), 40(2300), 41(2500)'
  },
  {
    'DeviceName': 'Micromax Canvas Juice 4G Q461',
    'Brand': 'Micromax',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Available. Released 2016, February',
    'dimensions': '143 x 71.8 x 9.4 mm (5.63 x 2.83 x 0.37 in)',
    'weight': '152 g (5.36 oz)',
    'sim': 'Dual SIM (Micro-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~67.1% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.0, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, IM',
    'browser': 'HTML',
    'java': 'No',
    'features_c': '- MP3/AAC/WAV player\r\n  - MP4/H.264 player\r\n  - Document viewer\r\n  - Photo editor',
    'battery_c': 'Non-removable Li-Ion 4000 mAh battery',
    'stand_by': 'Up to 450 h',
    'talk_time': 'Up to 14 h',
    'colors': 'Black',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Quad-core 1.0 GHz',
    'internal': '8 GB, 2 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '8 MP, autofocus, dual-LED flash',
    'video': 'Yes',
    'secondary': '5 MP',
    'speed': 'HSPA 21.1/5.76 Mbps, LTE Cat4 150/50 Mbps',
    'features': 'Geo-tagging, touch focus, face detection',
    'protection': 'Corning Gorilla Glass 3',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 2100 ',
    '_4g_bands': 'LTE band 3(1800), 5(850), 40(2300)'
  },
  {
    'DeviceName': 'Micromax Canvas Amaze 4G Q491',
    'Brand': 'Micromax',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Available. Released 2016, February',
    'dimensions': '-',
    'weight': '-',
    'sim': 'Dual SIM (Micro-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.0',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP3/AAC/WAV player\r\n  - MP4/H.264 player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Removable Li-Ion 2230 mAh battery',
    'stand_by': 'Up to 160 h',
    'talk_time': 'Up to 7 h',
    'colors': 'Black',
    'sensors': 'Accelerometer, gyro, proximity, compass',
    'cpu': 'Quad-core 1.2 GHz Cortex-A53',
    'internal': '8 GB, 1 GB RAM',
    'os': 'Android OS, v5.1.1 (Lollipop)',
    'primary_': '8 MP, autofocus, LED flash',
    'video': '720p',
    'secondary': '2 MP',
    'speed': 'HSPA 42.2/11.5 Mbps, LTE Cat4 150/50 Mbps',
    'chipset': 'Qualcomm MSM8916 Snapdragon 410',
    'features': 'Yes',
    'protection': 'Corning Gorilla Glass 3',
    'gpu': 'Adreno 306',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 2100 ',
    '_4g_bands': 'LTE band 3(1800), 7(2600), 20(800), 40(2300)'
  },
  {
    'DeviceName': 'ZTE Blade V Plus',
    'Brand': 'ZTE',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, January',
    'status': 'Available. Released 2016, February',
    'dimensions': '155.3 x 77.2 x 8.6 mm (6.11 x 3.04 x 0.34 in)',
    'weight': '164 g (5.78 oz)',
    'sim': 'Dual SIM (Nano-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.5 inches (~69.6% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~401 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB (uses SIM 2 slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0, A2DP, LE',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - MP4/H.264 player\r\n  - MP3/WAV/eAAC+ player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Non-removable Li-Ion 3000 mAh battery',
    'stand_by': 'Up to 220 h',
    'talk_time': 'Up to 9 h',
    'colors': 'Silver',
    'sensors': 'Fingerprint, accelerometer, gyro, proximity, compass',
    'cpu': 'Octa-core 1.3 GHz Cortex-A53',
    'internal': '16 GB, 2 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '13 MP, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP',
    'speed': 'HSPA 42.2/11.5 Mbps, LTE Cat4 150/50 Mbps',
    'chipset': 'Mediatek MT6753',
    'features': 'Geo-tagging, touch focus, face detection, HDR, panorama',
    'gpu': 'Mali-T720MP3',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 900 / 1800 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 7(2600), 28(700)'
  },
  {
    'DeviceName': 'Xiaomi Mi 4s',
    'Brand': 'Xiaomi',
    'technology': 'GSM / CDMA / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Available. Released 2016, March',
    'dimensions': '139.3 x 70.8 x 7.8 mm (5.48 x 2.79 x 0.31 in)',
    'weight': '133 g (4.69 oz)',
    'sim': 'Dual SIM (Micro-SIM/Nano-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~69.9% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~441 ppi pixel density)',
    'display_c': '- MIUI 7.0',
    'card_slot': 'microSD, up to 128 GB (uses SIM 2 slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 a/b/g/n/ac, dual-band, WiFi Direct, hotspot',
    'bluetooth': 'v4.1, A2DP',
    'gps': 'Yes, with A-GPS, GLONASS, BDS',
    'infrared_port': 'Yes',
    'radio': 'No',
    'usb': 'Type-C 1.0 reversible connector',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Fast battery charging: 40% in 60 min (Quick Charge 2.0)\r\n  - Active noise cancellation with dedicated mic\r\n  - XviD/DivX/MP4/H.265 player\r\n  - MP3/WAV/eAAC+/FLAC player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Non-removable Li-Ion 3260 mAh battery',
    'colors': 'Black, White, Gold, Pink',
    'sensors': 'Fingerprint, accelerometer, gyro, proximity, compass',
    'cpu': 'Quad-core 1.44 GHz Cortex-A53 & dual-core 1.82 GHz Cortex-A57',
    'internal': '64 GB, 3 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '13 MP, f/2.0, phase detection autofocus, dual-LED (dual tone) flash, check quality',
    'video': '1080p@30fps, 720p@120fps, check quality',
    'secondary': '5 MP, f/2.0, 1080p',
    'speed': 'HSPA, LTE Cat4 150/50 Mbps',
    'network_c': ' TD-SCDMA',
    'chipset': 'Qualcomm MSM8992 Snapdragon 808',
    'features': 'Geo-tagging, touch focus, face/smile detection, panorama, HDR',
    'gpu': 'Adreno 418',
    'multitouch': 'Yes',
    'loudspeaker': '  Voice 73dB / Noise 68dB / Ring 82dB    ',
    'audio_quality': '  Noise -94.9dB / Crosstalk -82.6dB',
    'camera': '  Photo / Video',
    'display': '  Contrast ratio: 975:1 (nominal), 2.095 (sunlight)',
    'performance': '  Basemark OS II: 1303 / Basemark OS II 2.0: 1545\r\nBasemark X: 12990',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 7(2600), 38(2600), 39(1900), 40(2300), 41(2500)'
  },
  {
    'DeviceName': 'Samsung Galaxy S7 edge (CDMA)',
    'Brand': 'Samsung',
    'technology': 'GSM / CDMA / HSPA / EVDO / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Available. Released 2016, March',
    'dimensions': '150.9 x 72.6 x 7.7 mm (5.94 x 2.86 x 0.30 in)',
    'weight': '157 g (5.54 oz)',
    'sim': 'Nano-SIM',
    'type': 'Super AMOLED capacitive touchscreen, 16M colors',
    'size': '5.5 inches (~76.1% screen-to-body ratio)',
    'resolution': '1440 x 2560 pixels (~534 ppi pixel density)',
    'display_c': '- Always-on display\r\n  - TouchWiz UI\r\n  - Curved edge screen',
    'card_slot': 'microSD, up to 200 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 a/b/g/n/ac, dual-band, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.2, A2DP, LE, apt-X',
    'gps': 'Yes, with A-GPS, GLONASS',
    'radio': 'No',
    'usb': 'microUSB v2.0, USB Host',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Fast battery charging: 60% in 30 min (Quick Charge 2.0)\r\n  - Wireless charging (PMA)\r\n  - ANT+ support\r\n  - S-Voice natural language commands and dictation\r\n  - OneDrive (115 GB cloud storage)\r\n  - Active noise cancellation with dedicated mic\r\n  - MP4/DivX/XviD/WMV/H.264 player\r\n  - MP3/WAV/WMA/eAAC+/FLAC player\r\n  - Photo/video editor\r\n  - Document editor',
    'battery_c': 'Non-removable Li-Ion 3600 mAh battery',
    'colors': 'Black Onyx, Silver Titanium, Gold Platinum',
    'sar_us': '  1.03 W/kg (head) &nbsp; &nbsp; 1.59 W/kg (body) &nbsp; &nbsp; ',
    'sensors': 'Fingerprint, accelerometer, gyro, proximity, compass, barometer, heart rate, SpO2',
    'cpu': 'Dual-core 2.15 GHz Kryo & dual-core 1.6 GHz Kryo',
    'internal': '32 GB, 4 GB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'body_c': '- Samsung Pay (Visa, MasterCard certified)\r\n  - IP68 certified - dust proof and water resistant over 1.5 meter and 30 minutes',
    'primary_': '12 MP, f/1.7, 26mm, phase detection autofocus, OIS, LED flash',
    'video': '2160p@30fps, 1080p@60fps, 720p@240fps, HDR, dual-video rec.',
    'secondary': '5 MP, f/1.7, 22mm, dual video call, Auto HDR',
    'speed': 'HSPA 42.2/5.76 Mbps, LTE Cat9 450/50 Mbps, EV-DO Rev.A 3.1 Mbps',
    'network_c': 'LTE band 1(2100), 2(1900), 3(1800), 4(1700/2100), 5(850), 7(2600), 12(700), 13(700), 20(800) - G935T',
    'chipset': 'Qualcomm MSM8996 Snapdragon 820',
    'features': '1/2.6\' sensor size, 1.4 Âµm pixel size, geo-tagging, simultaneous 4K video and 9MP image recording, touch focus, face/smile detection, Auto HDR, panorama',
    'protection': 'Corning Gorilla Glass 4',
    'gpu': 'Adreno 530',
    'multitouch': 'Yes',
    'nfc': 'Yes',
    'build': 'Corning Gorilla Glass 4 back panel',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 ',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 - G935A',
    '_4g_bands': 'LTE band 1(2100), 2(1900), 3(1800), 4(1700/2100), 5(850), 7(2600), 8(900), 12(700), 20(800), 29(700), 30(2300), 38(2600), 39(1900), 40(2300), 41(2500) - G935A'
  },
  {
    'DeviceName': 'Samsung Galaxy S7 (CDMA)',
    'Brand': 'Samsung',
    'technology': 'GSM / CDMA / HSPA / EVDO / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Available. Released 2016, March',
    'dimensions': '142.4 x 69.6 x 7.9 mm (5.61 x 2.74 x 0.31 in)',
    'weight': '152 g (5.36 oz)',
    'sim': 'Nano-SIM',
    'type': 'Super AMOLED capacitive touchscreen, 16M colors',
    'size': '5.1 inches (~72.3% screen-to-body ratio)',
    'resolution': '1440 x 2560 pixels (~576 ppi pixel density)',
    'display_c': '- Always-on display\r\n  - TouchWiz UI',
    'card_slot': 'microSD, up to 200 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 a/b/g/n/ac, dual-band, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.2, A2DP, LE, apt-X',
    'gps': 'Yes, with A-GPS, GLONASS',
    'radio': 'No',
    'usb': 'microUSB v2.0, USB Host',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Fast battery charging: 60% in 30 min (Quick Charge 2.0)\r\n  - Wireless charging (PMA)\r\n  - ANT+ support\r\n  - S-Voice natural language commands and dictation\r\n  - OneDrive (115 GB cloud storage)\r\n  - Active noise cancellation with dedicated mic\r\n  - MP4/DivX/XviD/WMV/H.264 player\r\n  - MP3/WAV/WMA/eAAC+/FLAC player\r\n  - Photo/video editor\r\n  - Document editor',
    'battery_c': 'Non-removable Li-Ion 3000 mAh battery',
    'colors': 'Black Onyx, Silver Titanium, Gold Platinum',
    'sar_us': '  1.24 W/kg (head) &nbsp; &nbsp; 1.59 W/kg (body) &nbsp; &nbsp; ',
    'sensors': 'Fingerprint, accelerometer, gyro, proximity, compass, barometer, heart rate, SpO2',
    'cpu': 'Dual-core 2.15 GHz Kryo & dual-core 1.6 GHz Kryo',
    'internal': '32 GB, 4 GB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'body_c': '- Samsung Pay (Visa, MasterCard certified)\r\n  - IP68 certified - dust proof and water resistant over 1.5 meter and 30 minutes',
    'primary_': '12 MP, f/1.7, 26mm, phase detection autofocus, OIS, LED flash',
    'video': '2160p@30fps, 1080p@60fps, 720p@240fps, HDR, dual-video rec.',
    'secondary': '5 MP, f/1.7, 22mm, dual video call, Auto HDR',
    'speed': 'HSPA 42.2/5.76 Mbps, LTE Cat9 450/50 Mbps, EV-DO Rev.A 3.1 Mbps',
    'network_c': 'LTE band 2(1900), 4(1700/2100), 5(850), 12(700), 13(700), 17(700), 25(1900) - G930R',
    'chipset': 'Qualcomm MSM8996 Snapdragon 820',
    'features': '1/2.6\' sensor size, 1.4 Âµm pixel size, geo-tagging, simultaneous 4K video and 9MP image recording, touch focus, face/smile detection, Auto HDR, panorama',
    'protection': 'Corning Gorilla Glass 4',
    'gpu': 'Adreno 530',
    'multitouch': 'Yes',
    'nfc': 'Yes',
    'build': 'Corning Gorilla Glass 4 back panel',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 ',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 - G930A, G930V',
    '_4g_bands': 'LTE band 1(2100), 2(1900), 3(1800), 4(1700/2100), 5(850), 7(2600), 8(900), 12(700), 20(800), 29(700), 30(2300), 38(2600), 39(1900), 40(2300), 41(2500) - G930A'
  },
  {
    'DeviceName': 'XOLO Era X',
    'Brand': 'XOLO',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Available. Released 2016, February',
    'dimensions': '145.5 x 72 x 8.5 mm (5.73 x 2.83 x 0.33 in)',
    'weight': '-',
    'sim': 'Dual SIM',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~65.8% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.0',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/WAV/WMA/AAC player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Removable Li-Po 2500 mAh battery',
    'colors': 'Black',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Quad-core 1.5 GHz',
    'internal': '8 GB, 2 GB RAM',
    'os': 'Android OS, v5.1.1 (Lollipop), planned upgrade to v6.0 (Marshmallow)',
    'primary_': '8 MP, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP, LED flash',
    'speed': 'HSPA 21.1/5.76 Mbps, LTE Cat4 150/50 Mbps',
    'chipset': 'Spreadtrum SC9830A',
    'features': 'Geo-tagging, touch focus, face/smile detection, panorama, HDR',
    'protection': 'Corning Gorilla Glass',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 900 / 1800 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 2100 ',
    '_4g_bands': 'LTE band 3(1800), 5(850), 40(2300)'
  },
  {
    'DeviceName': 'XOLO Era 4K',
    'Brand': 'XOLO',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Available. Released 2016, February',
    'dimensions': '143 x 71.8 x 9.2 mm (5.63 x 2.83 x 0.36 in)',
    'weight': '-',
    'sim': 'Dual SIM',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~67.1% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.0',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/WAV/WMA/AAC player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Non-removable Li-Ion 4000 mAh battery',
    'stand_by': 'Up to 624 h (2G) / Up to 528 h (3G)',
    'talk_time': 'Up to 32 h (2G) / Up to 17 h (3G)',
    'colors': 'Blue, White',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Quad-core 1.0 GHz',
    'internal': '8 GB, 2 GB RAM',
    'os': 'Android OS, v5.1.1 (Lollipop)',
    'primary_': '8 MP, f/2.0, autofocus, Dual-LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP, f/2.2',
    'speed': 'HSPA 42.2/11.5 Mbps, LTE Cat4 150/50 Mbps',
    'chipset': 'Mediatek MT6735P',
    'features': 'Geo-tagging, touch focus, face/smile detection, panorama, HDR',
    'protection': 'Corning Gorilla Glass 3',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 900 / 1800 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 2100 ',
    '_4g_bands': 'LTE band 3(1800), 40(2300)'
  },
  {
    'DeviceName': 'Sony Xperia XA Dual',
    'Brand': 'Sony',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Up to 85.6 kbps',
    'edge': 'Up to 236.8 kbps',
    'announced': '2016, February',
    'status': 'Coming soon',
    'dimensions': '143.6 x 66.8 x 7.9 mm (5.65 x 2.63 x 0.31 in)',
    'weight': '137.4 g (4.83 oz)',
    'sim': 'Dual SIM (Nano-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~71.8% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'card_slot': 'microSD, up to 200 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 a/b/g/n, Wi-Fi Direct, DLNA, hotspot',
    'bluetooth': 'v4.1, A2DP, LE, apt-X',
    'gps': 'Yes, with A-GPS, GLONASS',
    'radio': 'FM radio, RDS',
    'usb': 'microUSB v2.0, USB Host',
    'messaging': 'SMS (threaded view), MMS, Email, IM, Push Email',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - Xvid/MP4/H.264 player\r\n  - MP3/eAAC+/WAV/Flac player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Non-removable Li-Ion 2300 mAh battery',
    'stand_by': 'Up to 466 h (2G) / Up to 466 h (3G)',
    'talk_time': 'Up to 11 h 20 min (2G) / Up to 10 h (3G)',
    'colors': 'White, Graphite Black, Lime Gold, Rose Gold',
    'sensors': 'Accelerometer, proximity, compass',
    'cpu': 'Octa-core 2.0 GHz Cortex-A53',
    'internal': '16 GB, 2 GB RAM',
    'os': 'Android OS, v6.0.1 (Marshmallow)',
    'primary_': '13 MP, phase detection autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '8 MP, 1/4\' sensor size, autofocus, 1080p, HDR',
    'speed': 'HSPA 42.2/5.76 Mbps, LTE Cat4 150/50 Mbps',
    'network_c': 'LTE band 1(2100), 3(1800), 5(850), 7(2600), 8(900), 28(700), 38(2600), 39(1900), 40(2300), 41(2500) - F3116',
    'chipset': 'Mediatek MT6755 Helio P10',
    'features': '1/3\' sensor size, geo-tagging, touch focus, face detection, HDR, panorama',
    'music_play': 'Up to 55 h',
    'protection': 'Scratch-resistant glass',
    'gpu': 'Mali-T860MP2',
    'multitouch': 'Yes, up to 4 fingers',
    'nfc': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 - F3112, ',
    '_4g_bands': 'LTE band 1(2100), 2(1900), 3(1800), 5(850), 7(2600), 8(900), 20(800) - F3112'
  },
  {
    'DeviceName': 'Acer Liquid Jade 2',
    'Brand': 'Acer',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Coming soon',
    'dimensions': '-',
    'weight': '-',
    'sim': 'Dual SIM (Nano-SIM, dual stand-by)',
    'type': 'Super AMOLED capacitive touchscreen, 16M colors',
    'size': '5.5 inches',
    'resolution': '1080 x 1920 pixels (~401 ppi pixel density)',
    'card_slot': 'microSD, up to 200 GB',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'sound_c': '- DTS sound',
    'wlan': 'Wi-Fi 802.11 a/b/g/n/ac, dual-band, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0, A2DP, LE',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS (threaded view), MMS, Email, Push Email',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP3/WAV/AAC player\r\n  - MP4/H.264 player\r\n  - Photo/video editor\r\n  - Document viewer',
    'colors': 'Black',
    'sensors': 'Accelerometer, gyro, proximity, compass',
    'internal': '32 GB, 3 GB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'primary_': '21 MP, autofocus, dual-LED flash',
    'video': '2160p@30fps',
    'secondary': '8 MP',
    'speed': 'HSPA 42.2/5.76 Mbps, LTE Cat4 150/50 Mbps',
    'chipset': 'Qualcomm MSM8992 Snapdragon 808',
    'features': 'Geo-tagging, touch focus, face detection, HDR, panorama',
    'protection': 'Corning Gorilla Glass 4',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 2100 ',
    '_4g_bands': ' LTE'
  },
  {
    'DeviceName': 'Acer Liquid Zest',
    'Brand': 'Acer',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Coming soon',
    'dimensions': '-',
    'weight': '-',
    'sim': 'Single SIM (Micro-SIM) or Dual SIM (Micro-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'card_slot': 'microSD (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'sound_c': '- DTS HD sound',
    'wlan': 'Yes',
    'bluetooth': 'v4.0, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'To be confirmed',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP3/WAV/AAC/Flac player\r\n  - MP4/H.264 player\r\n  - Photo/video editor\r\n  - Document viewer',
    'colors': 'Black, White',
    'sensors': 'Accelerometer, proximity, compass',
    'cpu': 'Quad-core 1.3 GHz - Z525\r\nQuad-core 1.0 GHz - Z528',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'primary_': '8 MP, f/2.0, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP',
    'speed': 'HSPA, LTE',
    'chipset': 'Mediatek MT6580 - Z525\r\nMediatek MT6735 - Z525',
    'features': 'Geo-tagging, touch focus, face detection, HDR, panorama',
    'gpu': 'Mali-400MP2 - Z525\r\nMali-T720MP2 - Z528',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2 (dual-SIM model only)',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': ' HSDPA',
    '_4g_bands': ' LTE'
  },
  {
    'DeviceName': 'HP Elite x3',
    'Brand': 'HP',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Coming soon. Exp. release 2016, June',
    'dimensions': '161.8 x 83.5 x 7.8 mm (6.37 x 3.29 x 0.31 in)',
    'weight': '195 g (6.88 oz)',
    'sim': 'Dual SIM (Nano-SIM, dual stand-by)',
    'type': 'Capacitive touchscreen, 16M colors',
    'size': '5.96 inches (~72.5% screen-to-body ratio)',
    'resolution': '1440 x 2560 pixels (~493 ppi pixel density)',
    'card_slot': 'microSD, up to 200 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes, with stereo speakers',
    'sound_c': '- Bang & Olufsen',
    'wlan': 'Wi-Fi 802.11 a/b/g/n/ac, dual-band, hotspot',
    'bluetooth': 'v4.1, A2DP',
    'gps': 'Yes, with A-GPS, GLONASS',
    'radio': 'No',
    'usb': 'v3.1, Type-C reversible connector',
    'messaging': 'SMS (threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Microsoft Continuum support\r\n  - Active noise cancellation with dedicated mic\r\n  - MP3/WAV/eAAC+ player\r\n  - MP4/H.265 player\r\n  - OneDrive (15 GB cloud storage)\r\n  - Document viewer\r\n  - Video/photo editor',
    'battery_c': 'Removable Li-Ion 4150 mAh battery',
    'colors': 'Black',
    'sensors': 'Iris scanner, accelerometer, gyro, proximity, compass',
    'cpu': 'Dual-core 2.15 GHz Kryo & dual-core 1.6 GHz Kryo',
    'internal': '64 GB, 4 GB RAM',
    'os': 'Microsoft Windows 10',
    'body_c': '- IP67 certified - dust and water resistant\r\n  - Water resistant up to 1 meter and 30 minutes\r\n  - MIL-STD 810G - grade salt, fog, humidity, transport shock and thermal shock resistant',
    'primary_': '16 MP, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '8 MP',
    'speed': 'HSPA 42.2/5.76 Mbps, LTE Cat4 150/50 Mbps',
    'chipset': 'Qualcomm MSM8996 Snapdragon 820',
    'features': 'Geo-tagging, touch focus, face detection, HDR, panorama',
    'protection': 'Corning Gorilla Glass 4',
    'gpu': 'Adreno 530',
    'multitouch': 'Yes',
    'nfc': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 ',
    '_4g_bands': ' LTE'
  },
  {
    'DeviceName': 'Lenovo Tab3 10',
    'Brand': 'Lenovo',
    'technology': 'GSM / HSPA',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Coming soon. Exp. release 2016, June',
    'dimensions': '-',
    'weight': '-',
    'sim': 'Micro-SIM',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '10.1 inches',
    'resolution': '1920 x 1200 pixels (~224 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.0',
    'gps': 'Yes, with A-GPS',
    'radio': 'No',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP3/WAV/WMA/AAC player\r\n  - MP4/H.264 player\r\n  - Document viewer\r\n  - Photo viewer/editor',
    'battery_c': 'Non-removable Li-Ion 7000 mAh battery',
    'colors': 'Black',
    'sensors': 'Accelerometer',
    'cpu': 'Quad-core 1.3 GHz',
    'internal': '32/64 GB, 2/3 GB RAM',
    'os': 'Android OS, v6.0.1 (Marshmallow)',
    'primary_': '8 MP',
    'video': 'Yes',
    'secondary': '3 MP',
    'speed': 'HSPA 21.1/5.76 Mbps',
    'chipset': 'Mediatek',
    'features': 'Geo-tagging',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 ',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 1900 / 2100 '
  },
  {
    'DeviceName': 'Lenovo Tab3 8',
    'Brand': 'Lenovo',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Coming soon. Exp. release 2016, June',
    'dimensions': '-',
    'weight': '-',
    'sim': 'Micro-SIM',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '8.0 inches',
    'resolution': '800 x 1280 pixels (~189 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.0',
    'gps': 'Yes, with A-GPS',
    'radio': 'No',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP3/WAV/WMA/AAC player\r\n  - MP4/H.264 player\r\n  - Document viewer\r\n  - Photo viewer/editor',
    'battery_c': 'Non-removable Li-Ion 4290 mAh battery',
    'colors': 'Black',
    'sensors': 'Accelerometer',
    'cpu': 'Quad-core 1.0 GHz',
    'internal': '16 GB, 1/2 GB RAM',
    'os': 'Android OS, v6.0.1 (Marshmallow)',
    'primary_': '5 MP',
    'video': 'Yes',
    'secondary': '2 MP',
    'speed': 'HSPA 21.1/5.76 Mbps, LTE Cat4 150/50 Mbps',
    'chipset': 'Mediatek',
    'features': 'Geo-tagging',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 ',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 1900 / 2100 ',
    '_4g_bands': ' LTE'
  },
  {
    'DeviceName': 'Lenovo Tab3 7',
    'Brand': 'Lenovo',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Coming soon. Exp. release 2016, June',
    'dimensions': '-',
    'weight': '-',
    'sim': 'Micro-SIM',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '7.0 inches',
    'resolution': '600 x 1024 pixels (~170 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.0',
    'gps': 'Yes, with A-GPS',
    'radio': 'No',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP3/WAV/WMA/AAC player\r\n  - MP4/H.264 player\r\n  - Document viewer\r\n  - Photo viewer/editor',
    'battery_c': 'Non-removable Li-Ion 3450 mAh battery',
    'colors': 'Black',
    'sensors': 'Accelerometer',
    'cpu': 'Quad-core 1.0 GHz',
    'internal': '16 GB, 1 GB RAM',
    'os': 'Android OS, v6.0.1 (Marshmallow)',
    'primary_': '5 MP',
    'video': 'Yes',
    'secondary': '2 MP',
    'speed': 'HSPA 21.1/5.76 Mbps, LTE Cat4 150/50 Mbps',
    'chipset': 'Mediatek',
    'features': 'Geo-tagging',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 ',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 1900 / 2100 ',
    '_4g_bands': ' LTE'
  },
  {
    'DeviceName': 'Sony Xperia XA',
    'Brand': 'Sony',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Up to 85.6 kbps',
    'edge': 'Up to 236.8 kbps',
    'announced': '2016, February',
    'status': 'Coming soon',
    'dimensions': '143.6 x 66.8 x 7.9 mm (5.65 x 2.63 x 0.31 in)',
    'weight': '137.4 g (4.83 oz)',
    'sim': 'Nano-SIM',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~71.8% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'card_slot': 'microSD, up to 200 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 a/b/g/n, Wi-Fi Direct, DLNA, hotspot',
    'bluetooth': 'v4.1, A2DP, LE, apt-X',
    'gps': 'Yes, with A-GPS, GLONASS',
    'radio': 'FM radio, RDS',
    'usb': 'microUSB v2.0, USB Host',
    'messaging': 'SMS (threaded view), MMS, Email, IM, Push Email',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - Xvid/MP4/H.264 player\r\n  - MP3/eAAC+/WAV/Flac player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Non-removable Li-Ion 2300 mAh battery',
    'stand_by': 'Up to 560 h (2G) / Up to 603 h (3G)',
    'talk_time': 'Up to 11 h 20 min (2G) / Up to 10 h (3G)',
    'colors': 'White, Graphite Black, Lime Gold, Rose Gold',
    'sensors': 'Accelerometer, proximity, compass',
    'cpu': 'Octa-core 2.0 GHz Cortex-A53',
    'internal': '16 GB, 2 GB RAM',
    'os': 'Android OS, v6.0.1 (Marshmallow)',
    'primary_': '13 MP, phase detection autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '8 MP, 1/4\' sensor size, autofocus, 1080p, HDR',
    'speed': 'HSPA 42.2/5.76 Mbps, LTE Cat4 150/50 Mbps',
    'network_c': 'LTE band 1(2100), 3(1800), 5(850), 7(2600), 8(900), 28(700), 38(2600), 39(1900), 40(2300), 41(2500) - F3115',
    'chipset': 'Mediatek MT6755 Helio P10',
    'features': '1/3\' sensor size, geo-tagging, touch focus, face detection, HDR, panorama',
    'music_play': 'Up to 55 h',
    'protection': 'Scratch-resistant glass',
    'gpu': 'Mali-T860MP2',
    'multitouch': 'Yes, up to 4 fingers',
    'nfc': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 ',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 - F3111, F3115',
    '_4g_bands': 'LTE band 1(2100), 2(1900), 3(1800), 5(850), 7(2600), 8(900), 20(800) - F3111'
  },
  {
    'DeviceName': 'Sony Xperia X Performance',
    'Brand': 'Sony',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Up to 107 kbps',
    'edge': 'Up to 296 kbps',
    'announced': '2016, February',
    'status': 'Coming soon',
    'dimensions': '143.7 x 70.4 x 8.7 mm (5.66 x 2.77 x 0.34 in)',
    'weight': '164.4 g (5.78 oz)',
    'sim': 'Single SIM (Nano-SIM) or Dual SIM (Nano-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~68.1% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~441 ppi pixel density)',
    'display_c': '- Triluminos display\r\n  - X-Reality Engine',
    'card_slot': 'microSD, up to 200 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes, with stereo speakers',
    'sound_c': '- High-Res audio',
    'wlan': 'Wi-Fi 802.11 a/b/g/n/ac, dual-band, Wi-Fi Direct, DLNA, hotspot',
    'bluetooth': 'v4.2, A2DP, apt-X, LE',
    'gps': 'Yes, with A-GPS, GLONASS/ BDS (region dependent)',
    'radio': 'No',
    'usb': 'microUSB v2.0, USB Host',
    'messaging': 'SMS (threaded view), MMS, Email, IM, Push Email',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - Xvid/MP4/H.265 player\r\n  - MP3/eAAC+/WAV/Flac player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Non-removable Li-Ion 2700 mAh battery',
    'colors': 'White, Graphite Black, Lime Gold, Rose Gold',
    'sensors': 'Fingerprint, accelerometer, gyro, proximity, barometer, compass',
    'cpu': 'Dual-core 2.15 GHz Kryo & dual-core 1.6 GHz Kryo',
    'internal': '32 GB, 3 GB RAM',
    'os': 'Android OS, v6.0.1 (Marshmallow)',
    'body_c': '- IP68 certified - dust proof and water resistant over 1.5 meter and 30 minutes',
    'primary_': '23 MP, f/2.0, 24mm, phase detection autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '13 MP, f/2.0, 22mm, 1/3\' sensor size, 1080p, HDR',
    'speed': 'HSPA 42.2/5.76 Mbps, LTE Cat9 450/50 Mbps',
    'chipset': 'Qualcomm MSM8996 Snapdragon 820',
    'features': '1/2.3\' sensor size, geo-tagging, touch focus, face detection, HDR, panorama',
    'protection': 'Scratch-resistant glass, oleophobic coating',
    'gpu': 'Adreno 530',
    'multitouch': 'Yes, up to 10 fingers',
    'nfc': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2 (dual-SIM model only)',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 800 / 850 / 900 / 1700(AWS) / 1900 / 2100 - F8131, F8132',
    '_4g_bands': 'LTE band 1(2100), 2(1900), 3(1800), 4(1700/2100), 5(850), 7(2600), 8(900), 12(700), 13(700), 17(700), 19(800), 20(800), 26(850), 28(700), 29(700), 38(2600), 39(1900), 40(2300), 41(2500) - F8131, F8132'
  },
  {
    'DeviceName': 'Sony Xperia X',
    'Brand': 'Sony',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Up to 107 kbps',
    'edge': 'Up to 296 kbps',
    'announced': '2016, February',
    'status': 'Coming soon',
    'dimensions': '142.7 x 69.4 x 7.9 mm (5.62 x 2.73 x 0.31 in)',
    'weight': '153 g (5.40 oz)',
    'sim': 'Single SIM (Nano-SIM) or Dual SIM (Nano-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~69.6% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~441 ppi pixel density)',
    'display_c': '- Triluminos display\r\n  - X-Reality Engine',
    'card_slot': 'microSD, up to 200 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes, with stereo speakers',
    'sound_c': '- High-Res audio',
    'wlan': 'Wi-Fi 802.11 a/b/g/n/ac, dual-band, Wi-Fi Direct, DLNA, hotspot',
    'bluetooth': 'v4.2, A2DP, apt-X, LE',
    'gps': 'Yes, with A-GPS, GLONASS',
    'radio': 'FM radio, RDS',
    'usb': 'microUSB v2.0, USB Host',
    'messaging': 'SMS (threaded view), MMS, Email, IM, Push Email',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - Xvid/MP4/H.265 player\r\n  - MP3/eAAC+/WAV/Flac player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Non-removable Li-Ion 2620 mAh battery',
    'colors': 'White, Graphite Black, Lime Gold, Rose Gold',
    'sensors': 'Fingerprint, accelerometer, gyro, proximity, barometer, compass',
    'cpu': 'Dual-core 1.8 GHz Cortex-A72 & quad-core 1.4 GHz Cortex-A53',
    'internal': '32/64 GB, 3 GB RAM',
    'os': 'Android OS, v6.0.1 (Marshmallow)',
    'primary_': '23 MP, f/2.0, 24mm, phase detection autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '13 MP, f/2.0, 22mm, 1/3\' sensor size, 1080p',
    'speed': 'HSPA 42.2/5.76 Mbps, LTE Cat6 300/50 Mbps',
    'chipset': 'Qualcomm MSM8956 Snapdragon 650',
    'features': '1/2.3\' sensor size, geo-tagging, touch focus, face detection, HDR, panorama',
    'protection': 'Scratch-resistant glass, oleophobic coating',
    'gpu': 'Adreno 510',
    'multitouch': 'Yes, up to 10 fingers',
    'nfc': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2 (dual-SIM model only)',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 800 / 850 / 900 / 1700(AWS) / 1900 / 2100 - F5121, F5122',
    '_4g_bands': 'LTE band 1(2100), 2(1900), 3(1800), 4(1700/2100), 5(850), 7(2600), 8(900), 12(700), 17(700), 19(800), 20(800), 26(850), 28(700), 38(2600), 39(1900), 40(2300), 41(2500) - F5121, F5122'
  },
  {
    'DeviceName': 'Lenovo Vibe K5 Plus',
    'Brand': 'Lenovo',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Coming soon. Exp. release 2016, April',
    'dimensions': '142 x 71 x 8 mm (5.59 x 2.80 x 0.31 in)',
    'weight': '142 g (5.01 oz)',
    'sim': 'Dual SIM',
    'type': 'IPS capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~68.4% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~441 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'sound_c': '- Dolby Audio',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.1, A2DP, LE',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0, USB On-The-Go',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - MP4/H.264 player\r\n  - MP3/WAV/eAAC+/FLAC player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Removable Li-Ion 2750 mAh battery',
    'colors': 'Silver, Gold',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Quad-core 1.5 GHz Cortex-A53 & quad-core 1.2 GHz Cortex-A53',
    'internal': '16 GB, 2 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '13 MP, autofocus, LED flash, check quality',
    'video': '1080p@30fps, check quality',
    'secondary': '5 MP',
    'speed': 'HSPA, LTE Cat4 150/50 Mbps',
    'chipset': 'Qualcomm MSM8939v2 Snapdragon 616',
    'features': 'Geo-tagging, touch focus, face detection, HDR, panorama',
    'gpu': 'Adreno 405',
    'multitouch': 'Yes',
    'camera': '  Photo / Video',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 ',
    '_4g_bands': ' LTE'
  },
  {
    'DeviceName': 'Lenovo Vibe K5',
    'Brand': 'Lenovo',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Coming soon. Exp. release 2016, April',
    'dimensions': '142 x 71 x 8 mm (5.59 x 2.80 x 0.31 in)',
    'weight': '142 g (5.01 oz)',
    'sim': 'Dual SIM',
    'type': 'IPS capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~68.4% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'sound_c': '- Dolby Audio',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.1, A2DP, LE',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0, USB On-The-Go',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - MP4/H.264 player\r\n  - MP3/WAV/eAAC+/FLAC player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Removable Li-Ion 2750 mAh battery',
    'colors': 'Silver, Gold',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Quad-core 1.5 GHz Cortex-A53 & quad-core 1.2 GHz Cortex-A53',
    'internal': '16 GB, 2 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '13 MP, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP',
    'speed': 'HSPA, LTE Cat4 150/50 Mbps',
    'chipset': 'Qualcomm MSM8929 Snapdragon 415',
    'features': 'Geo-tagging, touch focus, face detection, HDR, panorama',
    'gpu': 'Adreno 405',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 ',
    '_4g_bands': ' LTE'
  },
  {
    'DeviceName': 'Samsung Galaxy S7 edge',
    'Brand': 'Samsung',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Available. Released 2016, March',
    'dimensions': '150.9 x 72.6 x 7.7 mm (5.94 x 2.86 x 0.30 in)',
    'weight': '157 g (5.54 oz)',
    'sim': 'Single SIM (Nano-SIM) or Dual SIM (Nano-SIM, dual stand-by)',
    'type': 'Super AMOLED capacitive touchscreen, 16M colors',
    'size': '5.5 inches (~76.1% screen-to-body ratio)',
    'resolution': '1440 x 2560 pixels (~534 ppi pixel density)',
    'display_c': '- Always-on display\r\n  - TouchWiz UI\r\n  - Curved edge screen',
    'card_slot': 'microSD, up to 200 GB (dedicated slot) - single-SIM model\r\nmicroSD, up to 200 GB (uses SIM 2 slot) - dual-SIM model',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 a/b/g/n/ac, dual-band, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.2, A2DP, LE, apt-X',
    'gps': 'Yes, with A-GPS, GLONASS, BDS',
    'radio': 'No',
    'usb': 'microUSB v2.0, USB Host',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Fast battery charging: 60% in 30 min (Quick Charge 2.0)\r\n  - Wireless charging (Qi/PMA) - market dependent\r\n  - ANT+ support\r\n  - S-Voice natural language commands and dictation\r\n  - OneDrive (115 GB cloud storage)\r\n  - Active noise cancellation with dedicated mic\r\n  - MP4/DivX/XviD/WMV/H.264 player\r\n  - MP3/WAV/WMA/eAAC+/FLAC player\r\n  - Photo/video editor\r\n  - Document editor',
    'battery_c': 'Non-removable Li-Ion 3600 mAh battery',
    'talk_time': 'Up to 27 h (3G)',
    'colors': 'Black, White, Gold, Silver',
    'sar_us': '  1.17 W/kg (head) &nbsp; &nbsp; 1.59 W/kg (body) &nbsp; &nbsp; ',
    'sar_eu': '  0.26 W/kg (head) &nbsp; &nbsp; 0.51 W/kg (body) &nbsp; &nbsp; ',
    'sensors': 'Fingerprint, accelerometer, gyro, proximity, compass, barometer, heart rate, SpO2',
    'cpu': 'Dual-core 2.15 GHz Kryo & dual-core 1.6 GHz Kryo\r\nQuad-core 2.3 GHz Mongoose + quad-core 1.6 GHz Cortex-A53',
    'internal': '32/64 GB, 4 GB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'body_c': '- Samsung Pay (Visa, MasterCard certified)\r\n  - IP68 certified - dust proof and water resistant over 1.5 meter and 30 minutes',
    'primary_': '12 MP, f/1.7, 26mm, phase detection autofocus, OIS, LED flash, check quality',
    'video': '2160p@30fps, 1080p@60fps, 720p@240fps, HDR, dual-video rec., check quality',
    'secondary': '5 MP, f/1.7, 22mm, dual video call, Auto HDR',
    'speed': 'HSPA 42.2/5.76 Mbps, LTE Cat9 450/50 Mbps',
    'network_c': ' TD-SCDMA',
    'chipset': 'Qualcomm MSM8996 Snapdragon 820\r\nExynos 8890 Octa',
    'features': '1/2.6\' sensor size, 1.4 Âµm pixel size, geo-tagging, simultaneous 4K video and 9MP image recording, touch focus, face/smile detection, Auto HDR, panorama',
    'music_play': 'Up to 74 h',
    'protection': 'Corning Gorilla Glass 4',
    'gpu': 'Adreno 530\r\nMali-T880 MP12',
    'multitouch': 'Yes',
    'loudspeaker': '  Voice 66dB / Noise 62dB / Ring 66dB    ',
    'audio_quality': '  Noise -92.5dB / Crosstalk -92.2dB',
    'nfc': 'Yes',
    'camera': '  Photo / Video',
    'display': '  Contrast ratio: Infinite (nominal), 4.439 (sunlight)',
    'performance': '  Basemark OS II: 2107 / Basemark OS II 2.0: 2050\r\nBasemark X: 28480',
    'build': 'Corning Gorilla Glass 4 back panel',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2 (dual-SIM model only)',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1700(AWS) / 1900 / 2100 - G935F',
    '_4g_bands': 'LTE band 1(2100), 2(1900), 3(1800), 4(1700/2100), 5(850), 7(2600), 8(900), 12(700), 13(700), 17(700), 18(800), 19(800), 20(800), 25(1900), 26(850), 28(700), 38(2600), 39(1900), 40(2300), 41(2500) - G935F'
  },
  {
    'DeviceName': 'ZTE Blade V7 Lite',
    'Brand': 'ZTE',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Coming soon',
    'dimensions': '143.8 x 70 x 7.9 mm (5.66 x 2.76 x 0.31 in)',
    'weight': '-',
    'sim': 'Dual SIM',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~68.5% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'card_slot': 'microSD, up to 128 GB (uses SIM 2 slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/WAV/eAAC+ player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Non-removable Li-Ion 2500 mAh battery',
    'colors': 'Silver',
    'sensors': 'Fingerprint, accelerometer, proximity, compass',
    'cpu': 'Quad-core',
    'internal': '16 GB, 2 GB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'primary_': '8 MP, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '8 MP, LED flash',
    'speed': 'HSPA, LTE Cat4 150/50 Mbps',
    'chipset': 'Mediatek MT6735P',
    'features': 'Geo-tagging, touch focus, face detection, HDR, panorama',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 5(850), 7(2600), 8(900), 20(800), 40(2300)'
  },
  {
    'DeviceName': 'ZTE Blade V7',
    'Brand': 'ZTE',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Coming soon',
    'dimensions': '146 x 72.5 x 7.5 mm (5.75 x 2.85 x 0.30 in)',
    'weight': '-',
    'sim': 'Dual SIM',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.2 inches (~70.4% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~424 ppi pixel density)',
    'card_slot': 'microSD, up to 128 GB (uses SIM 2 slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0, USB Host',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - MP4/H.264 player\r\n  - MP3/WAV/eAAC+ player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Non-removable Li-Ion 2500 mAh battery',
    'colors': 'Gold, Gray',
    'sensors': 'Accelerometer, gyro, proximity, compass',
    'cpu': 'Octa-core 1.3 GHz Cortex-A53',
    'internal': '16 GB, 2 GB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'primary_': '13 MP, phase detection autofocus, dual-LED (dual tone) flash',
    'video': '1080p@30fps',
    'secondary': '5 MP',
    'speed': 'HSPA, LTE Cat4 150/50 Mbps',
    'network_c': 'LTE band 2(1900), 4(1700/2100), 7(2600), 12(700), 28(700)',
    'chipset': 'Mediatek MT6753',
    'features': 'Geo-tagging, touch focus, face detection, HDR, panorama',
    'gpu': 'Mali-T720MP3',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 7(2600), 8(900), 20(800)'
  },
  {
    'DeviceName': 'HTC Desire 825',
    'Brand': 'HTC',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Coming soon. Exp. release 2016, April',
    'dimensions': '156.9 x 76.9 x 7.4 mm (6.18 x 3.03 x 0.29 in)',
    'weight': '155 g (5.47 oz)',
    'sim': 'Single SIM (Nano-SIM) or Dual SIM (Nano-SIM, dual stand-by)',
    'type': 'Super LCD capacitive touchscreen, 16M colors',
    'size': '5.5 inches (~69.1% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~267 ppi pixel density)',
    'card_slot': 'microSD, up to 200 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'sound_c': '- Hi-Res Audio\r\n  - Dolby Audio',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.1, A2DP',
    'gps': 'Yes, with A-GPS, GLONASS',
    'radio': 'To be confirmed',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - MP4/H.264 player\r\n  - MP3/eAAC+/WAV player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Removable Li-Ion 2700 mAh battery',
    'colors': 'Various',
    'sensors': 'Accelerometer, proximity, compass',
    'cpu': 'Quad-core 1.6 GHz Cortex-A7',
    'internal': '16 GB, 2 GB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'primary_': '13 MP, f/2.2, 28mm, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP, f/2.8, 1080p',
    'speed': 'HSPA, LTE Cat4 150/50 Mbps',
    'chipset': 'Qualcomm Snapdragon 400',
    'features': 'Geo-tagging, touch focus, face detection, HDR, panorama',
    'protection': 'Corning Gorilla Glass (unspecified version)',
    'gpu': 'Adreno 305',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2 (dual-SIM model only)',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 5(850), 7(2600), 8(900), 20(800), 28(700), 40(2300)'
  },
  {
    'DeviceName': 'HTC Desire 630',
    'Brand': 'HTC',
    'technology': 'GSM / CDMA / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Coming soon. Exp. release 2016, April',
    'dimensions': '146.9 x 70.9 x 8.3 mm (5.78 x 2.79 x 0.33 in)',
    'weight': '140 g (4.94 oz)',
    'sim': 'Dual SIM (Nano-SIM, dual stand-by)',
    'type': 'Super LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~66.2% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'card_slot': 'microSD, up to 200 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'sound_c': '- Hi-Res Audio\r\n  - Dolby Audio',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.1, A2DP',
    'gps': 'Yes, with A-GPS, GLONASS',
    'radio': 'To be confirmed',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/eAAC+/WAV player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Removable Li-Ion 2200 mAh battery',
    'colors': 'Various',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Quad-core 1.6 GHz Cortex-A7',
    'internal': '16 GB, 2 GB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'primary_': '13 MP, f/2.4, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP, f/2.8',
    'speed': 'HSPA, LTE Cat4 150/50 Mbps',
    'network_c': 'CDMA 800 ',
    'chipset': 'Qualcomm Snapdragon 400',
    'features': 'Geo-tagging, touch focus, face detection, HDR, panorama',
    'gpu': 'Adreno 305',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 5(850), 8(900), 40(2300)'
  },
  {
    'DeviceName': 'HTC Desire 530',
    'Brand': 'HTC',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Available. Released 2016, March',
    'dimensions': '146.9 x 70.9 x 8.3 mm (5.78 x 2.79 x 0.33 in)',
    'weight': '140 g (4.94 oz)',
    'sim': 'Nano-SIM',
    'type': 'Super LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~66.2% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'card_slot': 'microSD, up to 200 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.1, A2DP',
    'gps': 'Yes, with A-GPS, GLONASS',
    'radio': 'To be confirmed',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/eAAC+/WAV player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Removable Li-Ion 2200 mAh battery',
    'colors': 'Various',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Quad-core 1.1 GHz Cortex-A7',
    'internal': '16 GB, 1.5 GB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'primary_': '8 MP, f/2.4, autofocus, LED flash',
    'video': '720p@30fps',
    'secondary': '5 MP, f/2.8',
    'speed': 'HSPA, LTE Cat4 150/50 Mbps',
    'chipset': 'Qualcomm MSM8909 Snapdragon 210',
    'features': 'Geo-tagging, touch focus, face detection, HDR, panorama',
    'gpu': 'Adreno 304',
    'multitouch': 'Yes',
    'nfc': 'Yes (market dependant)',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 ',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 5(850), 7(2600), 8(900), 20(800), 28(700)'
  },
  {
    'DeviceName': 'Lenovo A7000 Turbo',
    'Brand': 'Lenovo',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, January',
    'status': 'Available. Released 2016, January',
    'dimensions': '152.6 x 76.2 x 8 mm (6.01 x 3.00 x 0.31 in)',
    'weight': '150 g (5.29 oz)',
    'sim': 'Dual SIM (Micro-SIM, dual stand-by)',
    'type': 'IPS capacitive touchscreen, 16M colors',
    'size': '5.5 inches (~71.7% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~401 ppi pixel density)',
    'display_c': '- Vibe UI 2.0',
    'card_slot': 'microSD, up to 32 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'sound_c': '- Dolby Atmos',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.1, A2DP, LE',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0, USB On-The-Go',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - MP4/H.264 player\r\n  - MP3/WAV/eAAC+/FLAC player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Removable Li-Ion 2900 mAh battery',
    'colors': 'Matte Black',
    'sensors': 'Accelerometer, proximity, compass',
    'cpu': 'Octa-core 1.7 GHz Cortex-A53',
    'internal': '16 GB, 2 GB RAM',
    'os': 'Android OS, v5.0 (Lollipop)',
    'primary_': '13 MP, f/2.0, autofocus, dual-LED flash',
    'video': '1080p@30fps',
    'secondary': '5 MP, f/2.2',
    'speed': 'HSPA, LTE Cat4 150/50 Mbps',
    'chipset': 'Mediatek MT6752',
    'features': 'Geo-tagging, touch focus, face detection, HDR, panorama',
    'gpu': 'Mali-T760MP2',
    'multitouch': 'Yes, up to 5 fingers',
    '_2g_bands': 'GSM 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 2100 ',
    '_4g_bands': ' LTE'
  },
  {
    'DeviceName': 'ZTE Axon Max',
    'Brand': 'ZTE',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2015, December',
    'status': 'Available. Released 2015, December',
    'dimensions': '160 x 80 x 7.5 mm (6.30 x 3.15 x 0.30 in)',
    'weight': '188 g (6.63 oz)',
    'sim': 'Dual SIM (Nano-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '6.0 inches (~77.5% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~367 ppi pixel density)',
    'card_slot': 'microSD, up to 128 GB (uses SIM 2 slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0, A2DP, LE',
    'gps': 'Yes, with A-GPS, GLONASS/ BDS (region dependent)',
    'radio': 'To be confirmed',
    'usb': 'Type-C 1.0 reversible connector',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Fast battery charging: 60% in 30 min (Quick Charge 2.0)\r\n  - Active noise cancellation with dedicated mic\r\n  - MP4/H.264 player\r\n  - MP3/WAV/eAAC+ player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Non-removable Li-Po 4140 mAh battery',
    'colors': 'Gold',
    'sensors': 'Fingerprint, accelerometer, gyro, proximity, compass',
    'cpu': 'Octa-core 1.5 GHz Cortex-A53',
    'internal': '32 GB, 3 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '16 MP, f/1.9, phase detection autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '13 MP, f/2.2',
    'speed': 'HSPA 42.2/5.76 Mbps, LTE Cat4 150/50 Mbps',
    'chipset': 'Qualcomm MSM8952 Snapdragon 617',
    'features': 'Geo-tagging, touch focus, face detection, HDR, panorama',
    'gpu': 'Adreno 405',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': ' HSDPA',
    '_4g_bands': ' LTE'
  },
  {
    'DeviceName': 'alcatel Pop 4S',
    'Brand': 'alcatel',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Coming soon. Exp. release 2016, Q2',
    'dimensions': '152 x 77 x 7.9 mm (5.98 x 3.03 x 0.31 in)',
    'weight': '-',
    'sim': 'Single SIM (Micro-SIM) or Dual SIM (Micro-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.5 inches (~71.3% screen-to-body ratio)',
    'resolution': '1080 x 1920 pixels (~401 ppi pixel density)',
    'card_slot': 'microSD, up to 64 GB',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.2, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Fast battery charging\r\n  - MP3/AAC+/WAV/Flac player\r\n  - MP4/H.264 player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Removable Li-Ion 2960 mAh battery',
    'stand_by': 'Up to 500 h (2G) / Up to 480 h (3G)',
    'talk_time': 'Up to 15 h (2G) / Up to 12 h (3G)',
    'colors': 'Various',
    'sensors': 'Fingerprint, accelerometer, proximity/ gyro, compass (optional)',
    'cpu': 'Quad-core 1.8 GHz & quad-core 1.0 GHz',
    'internal': '16 GB, 2 GB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'primary_': '13 MP, f/2.0, phase detection autofocus, dual-LED (dual tone) flash',
    'video': '1080p@30fps',
    'secondary': '5 MP, LED flash',
    'speed': 'HSPA 42.2/5.76 Mbps, LTE Cat6 300/50 Mbps',
    'chipset': 'Mediatek MT6755M',
    'features': '1/3\' sensor size, geo-tagging, touch focus, face detection, panorama, HDR',
    'multitouch': 'Yes, up to 5 fingers',
    'nfc': 'Yes (optional)',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2 (dual-SIM model only)',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 ',
    '_4g_bands': 'LTE band 1(2100), 3(1800), 7(2600), 8(900), 20(800), 28(700)'
  },
  {
    'DeviceName': 'alcatel Pop 4+',
    'Brand': 'alcatel',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Coming soon. Exp. release 2016, Q2',
    'dimensions': '151 x 77 x 8 mm (5.94 x 3.03 x 0.31 in)',
    'weight': '-',
    'sim': 'Single SIM (Micro-SIM) or Dual SIM (Micro-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.5 inches (~31.8% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~401 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.1, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP3/AAC+/WAV/Flac player\r\n  - MP4/H.264 player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Removable Li-Ion 2500 mAh battery',
    'stand_by': 'Up to 525 h (2G) / Up to 500 h (3G)',
    'talk_time': 'Up to 18 h (2G) / Up to 15 h (3G)',
    'colors': 'Various',
    'sensors': 'Accelerometer, proximity, compass (optional)',
    'cpu': 'Quad-core 1.1 GHz Cortex-A7',
    'internal': '16 GB, 1.5 GB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'primary_': '8 MP, f/2.0, autofocus, LED flash',
    'video': '720p@30fps',
    'secondary': '5 MP, LED flash',
    'speed': 'HSPA 42.2/5.76 Mbps, LTE Cat4 150/50 Mbps',
    'network_c': 'HSDPA 850 / 900 / 1700(AWS) / 1900 / 2100 - 5056M',
    'chipset': 'Qualcomm MSM8909 Snapdragon 210',
    'features': 'Geo-tagging, face/smile detection, HDR, panorama',
    'gpu': 'Adreno 304',
    'multitouch': 'Yes, up to 5 fingers',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2 (dual-SIM model only)',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 ',
    '_4g_bands': ' LTE'
  },
  {
    'DeviceName': 'alcatel Pop 4',
    'Brand': 'alcatel',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Coming soon. Exp. release 2016, Q2',
    'dimensions': '140.7 x 71.4 x 8 mm (5.54 x 2.81 x 0.31 in)',
    'weight': '-',
    'sim': 'Single SIM (Micro-SIM) or Dual SIM (Micro-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~30.5% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~441 ppi pixel density)',
    'card_slot': 'microSD, up to 32/128 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0, A2DP',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Email, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP3/AAC+/WAV/Flac player\r\n  - MP4/H.264 player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Removable Li-Ion 2500 mAh battery',
    'stand_by': 'Up to 420 h (2G) / Up to 420 h (3G)',
    'talk_time': 'Up to 12 h (2G) / Up to 9 h (3G)',
    'colors': 'Various',
    'sensors': 'Accelerometer, proximity, compass (optional)',
    'cpu': 'Quad-core 1.1 GHz Cortex-A7',
    'internal': '8 GB, 1 GB RAM',
    'os': 'Android OS, v6.0 (Marshmallow)',
    'primary_': '8 MP, autofocus, LED flash',
    'video': '720p@30fps',
    'secondary': '5 MP, LED flash',
    'speed': 'HSPA 42.2/5.76 Mbps, LTE Cat4 150/50 Mbps',
    'chipset': 'Qualcomm MSM8909 Snapdragon 210',
    'features': 'Geo-tagging, face/smile detection, HDR, panorama',
    'gpu': 'Adreno 304',
    'multitouch': 'Yes, up to 5 fingers',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2 (dual-SIM model only)',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 ',
    '_4g_bands': ' LTE'
  },
  {
    'DeviceName': 'Samsung Gear S2 classic 3G',
    'Brand': 'Samsung',
    'technology': 'GSM / HSPA',
    'gprs': 'No',
    'edge': 'No',
    'announced': '2016, February',
    'status': 'Available. Released 2016, April',
    'dimensions': '44 x 46.9 x 13.4 mm (1.73 x 1.85 x 0.53 in)',
    'weight': '54 g (1.90 oz)',
    'sim': 'Electronic SIM card (e-SIM)',
    'type': 'Super AMOLED capacitive touchscreen, 16M colors',
    'size': '1.2 inches (~22.5% screen-to-body ratio)',
    'resolution': '360 x 360 pixels (~424 ppi pixel density)',
    'display_c': '- Always-on display\r\n  - Rotating bezel',
    'card_slot': 'No',
    'camera_c': 'No',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n/e',
    'bluetooth': 'v4.1',
    'gps': 'No',
    'radio': 'No',
    'usb': 'No',
    'messaging': 'SMS(threaded view), MMS, Email, IM',
    'browser': 'No',
    'java': 'No',
    'features_c': '- Wireless charging\r\n  - S-Voice natural language commands and dictation\r\n  - MP3/M4A/AAC/WAV player\r\n  - Photo viewer\r\n  - Voice memo/dial/commands',
    'battery_c': 'Non-removable Li-Ion 300 mAh battery',
    'stand_by': 'Up to 48 h (3G)',
    'talk_time': 'Up to 48 h (mixed usage)',
    'colors': 'Black, Rose Gold, ceramic bracelet',
    'sensors': 'Accelerometer, gyro, heart rate, barometer',
    'cpu': 'Dual-core 1.0 GHz Cortex-A7',
    'internal': '4 GB, 512 MB RAM',
    'os': 'Tizen-based wearable platform',
    'body_c': '- Samsung Pay\r\n  - IP68 certified - dust proof and water resistant over 1.5 meter and 30 minutes\r\n  - Compatible with standard 20mm straps',
    'chipset': 'Exynos 3250 Dual',
    'protection': 'Corning Gorilla Glass 3',
    'gpu': 'Mali-400MP2',
    'multitouch': 'Yes',
    'nfc': 'Yes',
    'build': 'Stainless Steel',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 ',
    '_3_5mm_jack_': 'No',
    '_3g_bands': ' HSDPA'
  },
  {
    'DeviceName': 'Yezz Monte Carlo 55 LTE VR',
    'Brand': 'Yezz',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2015, December',
    'status': 'Available. Released 2016, March',
    'dimensions': '152 x 77.9 x 7 mm (5.98 x 3.07 x 0.28 in)',
    'weight': '165 g (5.82 oz)',
    'sim': 'Dual SIM (Micro-SIM/Nano-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.5 inches (~70.4% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~267 ppi pixel density)',
    'card_slot': 'microSD, up to 64 GB (uses SIM 2 slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0, LE',
    'gps': 'Yes, with A-GPS, GLONASS',
    'radio': 'Stereo FM radio',
    'usb': 'microUSB v2.0, USB Host',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Includes VR viewer headset\r\n  - Active noise cancellation with dedicated mic\r\n  - MP4/H.264 player\r\n  - MP3/eAAC+/WAV/FLAC player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Non-removable Li-Po 3000 mAh battery',
    'stand_by': 'Up to 300 h (2G) / Up to 250 h (3G)',
    'talk_time': 'Up to 22 h 10 min (2G) / Up to 18 h 30 min (3G)',
    'colors': 'Black',
    'sensors': 'Accelerometer, gyro, proximity, compass',
    'cpu': 'Octa-core 1.3 GHz Cortex-A53',
    'internal': '8 GB, 1 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '20 MP, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '8 MP, LED flash',
    'speed': 'HSPA 42.2/11.5 Mbps, LTE Cat4 150/50 Mbps',
    'chipset': 'Mediatek MT6753',
    'features': 'Geo-tagging, touch focus, face detection, panorama, HDR',
    'gpu': 'Mali-T720MP3',
    'multitouch': 'No',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 - MCM55TL142',
    '_4g_bands': 'LTE band 2(1900), 3(1800), 7(2600), 20(800) - MCM55TL142'
  },
  {
    'DeviceName': 'Yezz Monte Carlo 55 LTE',
    'Brand': 'Yezz',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2015, December',
    'status': 'Available. Released 2016, March',
    'dimensions': '152 x 77.9 x 7 mm (5.98 x 3.07 x 0.28 in)',
    'weight': '165 g (5.82 oz)',
    'sim': 'Dual SIM (Micro-SIM/Nano-SIM, dual stand-by)',
    'type': 'IPS LCD capacitive touchscreen, 16M colors',
    'size': '5.5 inches (~70.4% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~267 ppi pixel density)',
    'card_slot': 'microSD, up to 64 GB (uses SIM 2 slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, Wi-Fi Direct, hotspot',
    'bluetooth': 'v4.0, LE',
    'gps': 'Yes, with A-GPS',
    'radio': 'Stereo FM radio',
    'usb': 'microUSB v2.0, USB Host',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- Active noise cancellation with dedicated mic\r\n  - MP4/H.264 player\r\n  - MP3/eAAC+/WAV/FLAC player\r\n  - Document viewer\r\n  - Photo/video editor',
    'battery_c': 'Non-removable Li-Po 3000 mAh battery',
    'stand_by': 'Up to 300 h (2G) / Up to 250 h (3G)',
    'talk_time': 'Up to 22 h 10 min (2G) / Up to 18 h 30 min (3G)',
    'colors': 'Black',
    'sensors': 'Accelerometer, gyro, proximity, compass',
    'cpu': 'Octa-core 1.3 GHz Cortex-A53',
    'internal': '8 GB, 1 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop)',
    'primary_': '20 MP, autofocus, LED flash',
    'video': '1080p@30fps',
    'secondary': '8 MP, LED flash',
    'speed': 'HSPA 42.2/11.5 Mbps, LTE Cat4 150/50 Mbps',
    'chipset': 'Mediatek MT6753',
    'features': 'Geo-tagging, touch focus, face detection, panorama, HDR',
    'gpu': 'Mali-T720MP3',
    'multitouch': 'No',
    '_2g_bands': 'GSM 850 / 900 / 1800 / 1900 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 850 / 900 / 1900 / 2100 - MCM55TL142',
    '_4g_bands': 'LTE band 2(1900), 3(1800), 7(2600), 20(800) - MCM55TL142'
  },
  {
    'DeviceName': 'Lava A71',
    'Brand': 'Lava',
    'technology': 'GSM / HSPA / LTE',
    'gprs': 'Yes',
    'edge': 'Yes',
    'announced': '2016, February',
    'status': 'Available. Released 2016, February',
    'dimensions': '145.5 x 72 x 8.5 mm (5.73 x 2.83 x 0.33 in)',
    'weight': '-',
    'sim': 'Dual SIM',
    'type': 'Capacitive touchscreen, 16M colors',
    'size': '5.0 inches (~65.8% screen-to-body ratio)',
    'resolution': '720 x 1280 pixels (~294 ppi pixel density)',
    'card_slot': 'microSD, up to 32 GB (dedicated slot)',
    'alert_types': 'Vibration; MP3, WAV ringtones',
    'loudspeaker_': 'Yes',
    'wlan': 'Wi-Fi 802.11 b/g/n, hotspot',
    'bluetooth': 'v4.0',
    'gps': 'Yes, with A-GPS',
    'radio': 'FM radio',
    'usb': 'microUSB v2.0',
    'messaging': 'SMS(threaded view), MMS, Email, Push Mail, IM',
    'browser': 'HTML5',
    'java': 'No',
    'features_c': '- MP4/H.264 player\r\n  - MP3/WAV/eAAC+ player\r\n  - Photo/video editor\r\n  - Document viewer',
    'battery_c': 'Removable Li-Po 2500 mAh battery',
    'colors': 'Dark blue',
    'sensors': 'Accelerometer, proximity',
    'cpu': 'Quad-core 1.5 GHz',
    'internal': '8 GB, 1 GB RAM',
    'os': 'Android OS, v5.1 (Lollipop), upgradable to v6.0 (Marshmallow)',
    'primary_': '5 MP, LED flash',
    'video': '1080p',
    'secondary': '2 MP, LED flash',
    'speed': 'HSPA',
    'features': 'Geo-tagging, touch focus, panorama',
    'protection': 'Corning Gorilla Glass',
    'multitouch': 'Yes',
    '_2g_bands': 'GSM 900 / 1800 - SIM 1 & SIM 2',
    '_3_5mm_jack_': 'Yes',
    '_3g_bands': 'HSDPA 900 / 2100 ',
    '_4g_bands': 'LTE band 3(1800), 5(850), 40(2300)'
  }
]);
